/* Zeta API - Z/formats/character set/DOS CP737.h
 ______ ____________  ___
|__   /|  ___|__  __|/   \
  /  /_|  __|  |  | /  *  \
 /_____|_____| |__|/__/ \__\
Copyright (C) 2006-2022 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef Z_formats_character_set_DOS_CP737_H
#define Z_formats_character_set_DOS_CP737_H

/* From 00h to 7Fh like ASCII */
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_ALPHA			       0x80
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_BETA			       0x81
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_GAMMA			       0x82
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_DELTA			       0x83
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_EPSILON		       0x84
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_ZETA			       0x85
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_ETA			       0x86
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_THETA			       0x87
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_IOTA			       0x88
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_KAPPA			       0x89
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_LAMDA			       0x8A
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_MU			       0x8B
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_NU			       0x8C
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_XI			       0x8D
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_OMICRON		       0x8E
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_PI			       0x8F
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_RHO			       0x90
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_SIGMA			       0x91
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_TAU			       0x92
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_UPSILON		       0x93
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_PHI			       0x94
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_CHI			       0x95
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_PSI			       0x96
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_OMEGA			       0x97
#define Z_DOS_CP737_GREEK_SMALL_LETTER_ALPHA			       0x98
#define Z_DOS_CP737_GREEK_SMALL_LETTER_BETA			       0x99
#define Z_DOS_CP737_GREEK_SMALL_LETTER_GAMMA			       0x9A
#define Z_DOS_CP737_GREEK_SMALL_LETTER_DELTA			       0x9B
#define Z_DOS_CP737_GREEK_SMALL_LETTER_EPSILON			       0x9C
#define Z_DOS_CP737_GREEK_SMALL_LETTER_ZETA			       0x9D
#define Z_DOS_CP737_GREEK_SMALL_LETTER_ETA			       0x9E
#define Z_DOS_CP737_GREEK_SMALL_LETTER_THETA			       0x9F
#define Z_DOS_CP737_GREEK_SMALL_LETTER_IOTA			       0xA0
#define Z_DOS_CP737_GREEK_SMALL_LETTER_KAPPA			       0xA1
#define Z_DOS_CP737_GREEK_SMALL_LETTER_LAMDA			       0xA2
#define Z_DOS_CP737_GREEK_SMALL_LETTER_MU			       0xA3
#define Z_DOS_CP737_GREEK_SMALL_LETTER_NU			       0xA4
#define Z_DOS_CP737_GREEK_SMALL_LETTER_XI			       0xA5
#define Z_DOS_CP737_GREEK_SMALL_LETTER_OMICRON			       0xA6
#define Z_DOS_CP737_GREEK_SMALL_LETTER_PI			       0xA7
#define Z_DOS_CP737_GREEK_SMALL_LETTER_RHO			       0xA8
#define Z_DOS_CP737_GREEK_SMALL_LETTER_SIGMA			       0xA9
#define Z_DOS_CP737_GREEK_SMALL_LETTER_FINAL_SIGMA		       0xAA
#define Z_DOS_CP737_GREEK_SMALL_LETTER_TAU			       0xAB
#define Z_DOS_CP737_GREEK_SMALL_LETTER_UPSILON			       0xAC
#define Z_DOS_CP737_GREEK_SMALL_LETTER_PHI			       0xAD
#define Z_DOS_CP737_GREEK_SMALL_LETTER_CHI			       0xAE
#define Z_DOS_CP737_GREEK_SMALL_LETTER_PSI			       0xAF
#define Z_DOS_CP737_LIGHT_SHADE					       0xB0
#define Z_DOS_CP737_MEDIUM_SHADE				       0xB1
#define Z_DOS_CP737_DARK_SHADE					       0xB2
#define Z_DOS_CP737_BOX_DRAWINGS_LIGHT_VERTICAL			       0xB3
#define Z_DOS_CP737_BOX_DRAWINGS_LIGHT_VERTICAL_AND_LEFT	       0xB4
#define Z_DOS_CP737_BOX_DRAWINGS_VERTICAL_SINGLE_AND_LEFT_DOUBLE       0xB5
#define Z_DOS_CP737_BOX_DRAWINGS_VERTICAL_DOUBLE_AND_LEFT_SINGLE       0xB6
#define Z_DOS_CP737_BOX_DRAWINGS_DOWN_DOUBLE_AND_LEFT_SINGLE	       0xB7
#define Z_DOS_CP737_BOX_DRAWINGS_DOWN_SINGLE_AND_LEFT_DOUBLE	       0xB8
#define Z_DOS_CP737_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_LEFT	       0xB9
#define Z_DOS_CP737_BOX_DRAWINGS_DOUBLE_VERTICAL		       0xBA
#define Z_DOS_CP737_BOX_DRAWINGS_DOUBLE_DOWN_AND_LEFT		       0xBB
#define Z_DOS_CP737_BOX_DRAWINGS_DOUBLE_UP_AND_LEFT		       0xBC
#define Z_DOS_CP737_BOX_DRAWINGS_UP_DOUBLE_AND_LEFT_SINGLE	       0xBD
#define Z_DOS_CP737_BOX_DRAWINGS_UP_SINGLE_AND_LEFT_DOUBLE	       0xBE
#define Z_DOS_CP737_BOX_DRAWINGS_LIGHT_DOWN_AND_LEFT		       0xBF
#define Z_DOS_CP737_BOX_DRAWINGS_LIGHT_UP_AND_RIGHT		       0xC0
#define Z_DOS_CP737_BOX_DRAWINGS_LIGHT_UP_AND_HORIZONTAL	       0xC1
#define Z_DOS_CP737_BOX_DRAWINGS_LIGHT_DOWN_AND_HORIZONTAL	       0xC2
#define Z_DOS_CP737_BOX_DRAWINGS_LIGHT_VERTICAL_AND_RIGHT	       0xC3
#define Z_DOS_CP737_BOX_DRAWINGS_LIGHT_HORIZONTAL		       0xC4
#define Z_DOS_CP737_BOX_DRAWINGS_LIGHT_VERTICAL_AND_HORIZONTAL	       0xC5
#define Z_DOS_CP737_BOX_DRAWINGS_VERTICAL_SINGLE_AND_RIGHT_DOUBLE      0xC6
#define Z_DOS_CP737_BOX_DRAWINGS_VERTICAL_DOUBLE_AND_RIGHT_SINGLE      0xC7
#define Z_DOS_CP737_BOX_DRAWINGS_DOUBLE_UP_AND_RIGHT		       0xC8
#define Z_DOS_CP737_BOX_DRAWINGS_DOUBLE_DOWN_AND_RIGHT		       0xC9
#define Z_DOS_CP737_BOX_DRAWINGS_DOUBLE_UP_AND_HORIZONTAL	       0xCA
#define Z_DOS_CP737_BOX_DRAWINGS_DOUBLE_DOWN_AND_HORIZONTAL	       0xCB
#define Z_DOS_CP737_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_RIGHT	       0xCC
#define Z_DOS_CP737_BOX_DRAWINGS_DOUBLE_HORIZONTAL		       0xCD
#define Z_DOS_CP737_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_HORIZONTAL	       0xCE
#define Z_DOS_CP737_BOX_DRAWINGS_UP_SINGLE_AND_HORIZONTAL_DOUBLE       0xCF
#define Z_DOS_CP737_BOX_DRAWINGS_UP_DOUBLE_AND_HORIZONTAL_SINGLE       0xD0
#define Z_DOS_CP737_BOX_DRAWINGS_DOWN_SINGLE_AND_HORIZONTAL_DOUBLE     0xD1
#define Z_DOS_CP737_BOX_DRAWINGS_DOWN_DOUBLE_AND_HORIZONTAL_SINGLE     0xD2
#define Z_DOS_CP737_BOX_DRAWINGS_UP_DOUBLE_AND_RIGHT_SINGLE	       0xD3
#define Z_DOS_CP737_BOX_DRAWINGS_UP_SINGLE_AND_RIGHT_DOUBLE	       0xD4
#define Z_DOS_CP737_BOX_DRAWINGS_DOWN_SINGLE_AND_RIGHT_DOUBLE	       0xD5
#define Z_DOS_CP737_BOX_DRAWINGS_DOWN_DOUBLE_AND_RIGHT_SINGLE	       0xD6
#define Z_DOS_CP737_BOX_DRAWINGS_VERTICAL_DOUBLE_AND_HORIZONTAL_SINGLE 0xD7
#define Z_DOS_CP737_BOX_DRAWINGS_VERTICAL_SINGLE_AND_HORIZONTAL_DOUBLE 0xD8
#define Z_DOS_CP737_BOX_DRAWINGS_LIGHT_UP_AND_LEFT		       0xD9
#define Z_DOS_CP737_BOX_DRAWINGS_LIGHT_DOWN_AND_RIGHT		       0xDA
#define Z_DOS_CP737_FULL_BLOCK					       0xDB
#define Z_DOS_CP737_LOWER_HALF_BLOCK				       0xDC
#define Z_DOS_CP737_LEFT_HALF_BLOCK				       0xDD
#define Z_DOS_CP737_RIGHT_HALF_BLOCK				       0xDE
#define Z_DOS_CP737_UPPER_HALF_BLOCK				       0xDF
#define Z_DOS_CP737_GREEK_SMALL_LETTER_OMEGA			       0xE0
#define Z_DOS_CP737_GREEK_SMALL_LETTER_ALPHA_WITH_TONOS		       0xE1
#define Z_DOS_CP737_GREEK_SMALL_LETTER_EPSILON_WITH_TONOS	       0xE2
#define Z_DOS_CP737_GREEK_SMALL_LETTER_ETA_WITH_TONOS		       0xE3
#define Z_DOS_CP737_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA	       0xE4
#define Z_DOS_CP737_GREEK_SMALL_LETTER_IOTA_WITH_TONOS		       0xE5
#define Z_DOS_CP737_GREEK_SMALL_LETTER_OMICRON_WITH_TONOS	       0xE6
#define Z_DOS_CP737_GREEK_SMALL_LETTER_UPSILON_WITH_TONOS	       0xE7
#define Z_DOS_CP737_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA	       0xE8
#define Z_DOS_CP737_GREEK_SMALL_LETTER_OMEGA_WITH_TONOS		       0xE9
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_ALPHA_WITH_TONOS	       0xEA
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_EPSILON_WITH_TONOS	       0xEB
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_ETA_WITH_TONOS		       0xEC
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_IOTA_WITH_TONOS	       0xED
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_OMICRON_WITH_TONOS	       0xEE
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_UPSILON_WITH_TONOS	       0xEF
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_OMEGA_WITH_TONOS	       0xF0
#define Z_DOS_CP737_PLUS_MINUS_SIGN				       0xF1
#define Z_DOS_CP737_GREATER_THAN_OR_EQUAL_TO			       0xF2
#define Z_DOS_CP737_LESS_THAN_OR_EQUAL_TO			       0xF3
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_IOTA_WITH_DIALYTIKA	       0xF4
#define Z_DOS_CP737_GREEK_CAPITAL_LETTER_UPSILON_WITH_DIALYTIKA	       0xF5
#define Z_DOS_CP737_DIVISION_SIGN				       0xF6
#define Z_DOS_CP737_ALMOST_EQUAL_TO				       0xF7
#define Z_DOS_CP737_DEGREE_SIGN					       0xF8
#define Z_DOS_CP737_BULLET_OPERATOR				       0xF9
#define Z_DOS_CP737_MIDDLE_DOT					       0xFA
#define Z_DOS_CP737_SQUARE_ROOT					       0xFB
#define Z_DOS_CP737_SUPERSCRIPT_LATIN_SMALL_LETTER_N		       0xFC
#define Z_DOS_CP737_SUPERSCRIPT_TWO				       0xFD
#define Z_DOS_CP737_BLACK_SQUARE				       0xFE
#define Z_DOS_CP737_NO_BREAK_SPACE				       0xFF

#define Z_ARRAY_CONTENT_DOS_CP737_TO_UNICODE(_)					\
	_(0391), _(0392), _(0393), _(0394), _(0395), _(0396), _(0397), _(0398), \
	_(0399), _(039A), _(039B), _(039C), _(039D), _(039E), _(039F), _(03A0), \
	_(03A1), _(03A3), _(03A4), _(03A5), _(03A6), _(03A7), _(03A8), _(03A9), \
	_(03B1), _(03B2), _(03B3), _(03B4), _(03B5), _(03B6), _(03B7), _(03B8), \
	_(03B9), _(03BA), _(03BB), _(03BC), _(03BD), _(03BE), _(03BF), _(03C0), \
	_(03C1), _(03C3), _(03C2), _(03C4), _(03C5), _(03C6), _(03C7), _(03C8), \
	_(2591), _(2592), _(2593), _(2502), _(2524), _(2561), _(2562), _(2556), \
	_(2555), _(2563), _(2551), _(2557), _(255D), _(255C), _(255B), _(2510), \
	_(2514), _(2534), _(252C), _(251C), _(2500), _(253C), _(255E), _(255F), \
	_(255A), _(2554), _(2569), _(2566), _(2560), _(2550), _(256C), _(2567), \
	_(2568), _(2564), _(2565), _(2559), _(2558), _(2552), _(2553), _(256B), \
	_(256A), _(2518), _(250C), _(2588), _(2584), _(258C), _(2590), _(2580), \
	_(03C9), _(03AC), _(03AD), _(03AE), _(03CA), _(03AF), _(03CC), _(03CD), \
	_(03CB), _(03CE), _(0386), _(0388), _(0389), _(038A), _(038C), _(038E), \
	_(038F), _(00B1), _(2265), _(2264), _(03AA), _(03AB), _(00F7), _(2248), \
	_(00B0), _(2219), _(00B7), _(221A), _(207F), _(00B2), _(25A0), _(00A0)

#endif /* Z_formats_character_set_DOS_CP737_H */
