/* Zeta API - Z/formats/character set/DOS CP775.h
 ______ ____________  ___
|__   /|  ___|__  __|/   \
  /  /_|  __|  |  | /  *  \
 /_____|_____| |__|/__/ \__\
Copyright (C) 2006-2022 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef Z_formats_character_set_DOS_CP775_H
#define Z_formats_character_set_DOS_CP775_H

/* From 00h to 7Fh like ASCII */
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_C_WITH_ACUTE		0x80
#define Z_DOS_CP775_LATIN_SMALL_LETTER_U_WITH_DIAERESIS		0x81
#define Z_DOS_CP775_LATIN_SMALL_LETTER_E_WITH_ACUTE		0x82
#define Z_DOS_CP775_LATIN_SMALL_LETTER_A_WITH_MACRON		0x83
#define Z_DOS_CP775_LATIN_SMALL_LETTER_A_WITH_DIAERESIS		0x84
#define Z_DOS_CP775_LATIN_SMALL_LETTER_G_WITH_CEDILLA		0x85
#define Z_DOS_CP775_LATIN_SMALL_LETTER_A_WITH_RING_ABOVE	0x86
#define Z_DOS_CP775_LATIN_SMALL_LETTER_C_WITH_ACUTE		0x87
#define Z_DOS_CP775_LATIN_SMALL_LETTER_L_WITH_STROKE		0x88
#define Z_DOS_CP775_LATIN_SMALL_LETTER_E_WITH_MACRON		0x89
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_R_WITH_CEDILLA		0x8A
#define Z_DOS_CP775_LATIN_SMALL_LETTER_R_WITH_CEDILLA		0x8B
#define Z_DOS_CP775_LATIN_SMALL_LETTER_I_WITH_MACRON		0x8C
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_Z_WITH_ACUTE		0x8D
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_A_WITH_DIAERESIS	0x8E
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_A_WITH_RING_ABOVE	0x8F
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_E_WITH_ACUTE		0x90
#define Z_DOS_CP775_LATIN_SMALL_LETTER_AE			0x91
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_AE			0x92
#define Z_DOS_CP775_LATIN_SMALL_LETTER_O_WITH_MACRON		0x93
#define Z_DOS_CP775_LATIN_SMALL_LETTER_O_WITH_DIAERESIS		0x94
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_G_WITH_CEDILLA		0x95
#define Z_DOS_CP775_CENT_SIGN					0x96
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_S_WITH_ACUTE		0x97
#define Z_DOS_CP775_LATIN_SMALL_LETTER_S_WITH_ACUTE		0x98
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_O_WITH_DIAERESIS	0x99
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS	0x9A
#define Z_DOS_CP775_LATIN_SMALL_LETTER_O_WITH_STROKE		0x9B
#define Z_DOS_CP775_POUND_SIGN					0x9C
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_O_WITH_STROKE		0x9D
#define Z_DOS_CP775_MULTIPLICATION_SIGN				0x9E
#define Z_DOS_CP775_CURRENCY_SIGN				0x9F
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_A_WITH_MACRON		0xA0
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_I_WITH_MACRON		0xA1
#define Z_DOS_CP775_LATIN_SMALL_LETTER_O_WITH_ACUTE		0xA2
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_Z_WITH_DOT_ABOVE	0xA3
#define Z_DOS_CP775_LATIN_SMALL_LETTER_Z_WITH_DOT_ABOVE		0xA4
#define Z_DOS_CP775_LATIN_SMALL_LETTER_Z_WITH_ACUTE		0xA5
#define Z_DOS_CP775_RIGHT_DOUBLE_QUOTATION_MARK			0xA6
#define Z_DOS_CP775_BROKEN_BAR					0xA7
#define Z_DOS_CP775_COPYRIGHT_SIGN				0xA8
#define Z_DOS_CP775_REGISTERED_SIGN				0xA9
#define Z_DOS_CP775_NOT_SIGN					0xAA
#define Z_DOS_CP775_VULGAR_FRACTION_ONE_HALF			0xAB
#define Z_DOS_CP775_VULGAR_FRACTION_ONE_QUARTER			0xAC
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_L_WITH_STROKE		0xAD
#define Z_DOS_CP775_LEFT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK	0xAE
#define Z_DOS_CP775_RIGHT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK	0xAF
#define Z_DOS_CP775_LIGHT_SHADE					0xB0
#define Z_DOS_CP775_MEDIUM_SHADE				0xB1
#define Z_DOS_CP775_DARK_SHADE					0xB2
#define Z_DOS_CP775_BOX_DRAWINGS_LIGHT_VERTICAL			0xB3
#define Z_DOS_CP775_BOX_DRAWINGS_LIGHT_VERTICAL_AND_LEFT	0xB4
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_A_WITH_OGONEK		0xB5
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_C_WITH_CARON		0xB6
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_E_WITH_OGONEK		0xB7
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_E_WITH_DOT_ABOVE	0xB8
#define Z_DOS_CP775_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_LEFT	0xB9
#define Z_DOS_CP775_BOX_DRAWINGS_DOUBLE_VERTICAL		0xBA
#define Z_DOS_CP775_BOX_DRAWINGS_DOUBLE_DOWN_AND_LEFT		0xBB
#define Z_DOS_CP775_BOX_DRAWINGS_DOUBLE_UP_AND_LEFT		0xBC
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_I_WITH_OGONEK		0xBD
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_S_WITH_CARON		0xBE
#define Z_DOS_CP775_BOX_DRAWINGS_LIGHT_DOWN_AND_LEFT		0xBF
#define Z_DOS_CP775_BOX_DRAWINGS_LIGHT_UP_AND_RIGHT		0xC0
#define Z_DOS_CP775_BOX_DRAWINGS_LIGHT_UP_AND_HORIZONTAL	0xC1
#define Z_DOS_CP775_BOX_DRAWINGS_LIGHT_DOWN_AND_HORIZONTAL	0xC2
#define Z_DOS_CP775_BOX_DRAWINGS_LIGHT_VERTICAL_AND_RIGHT	0xC3
#define Z_DOS_CP775_BOX_DRAWINGS_LIGHT_HORIZONTAL		0xC4
#define Z_DOS_CP775_BOX_DRAWINGS_LIGHT_VERTICAL_AND_HORIZONTAL	0xC5
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_U_WITH_OGONEK		0xC6
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_U_WITH_MACRON		0xC7
#define Z_DOS_CP775_BOX_DRAWINGS_DOUBLE_UP_AND_RIGHT		0xC8
#define Z_DOS_CP775_BOX_DRAWINGS_DOUBLE_DOWN_AND_RIGHT		0xC9
#define Z_DOS_CP775_BOX_DRAWINGS_DOUBLE_UP_AND_HORIZONTAL	0xCA
#define Z_DOS_CP775_BOX_DRAWINGS_DOUBLE_DOWN_AND_HORIZONTAL	0xCB
#define Z_DOS_CP775_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_RIGHT	0xCC
#define Z_DOS_CP775_BOX_DRAWINGS_DOUBLE_HORIZONTAL		0xCD
#define Z_DOS_CP775_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_HORIZONTAL	0xCE
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_Z_WITH_CARON		0xCF
#define Z_DOS_CP775_LATIN_SMALL_LETTER_A_WITH_OGONEK		0xD0
#define Z_DOS_CP775_LATIN_SMALL_LETTER_C_WITH_CARON		0xD1
#define Z_DOS_CP775_LATIN_SMALL_LETTER_E_WITH_OGONEK		0xD2
#define Z_DOS_CP775_LATIN_SMALL_LETTER_E_WITH_DOT_ABOVE		0xD3
#define Z_DOS_CP775_LATIN_SMALL_LETTER_I_WITH_OGONEK		0xD4
#define Z_DOS_CP775_LATIN_SMALL_LETTER_S_WITH_CARON		0xD5
#define Z_DOS_CP775_LATIN_SMALL_LETTER_U_WITH_OGONEK		0xD6
#define Z_DOS_CP775_LATIN_SMALL_LETTER_U_WITH_MACRON		0xD7
#define Z_DOS_CP775_LATIN_SMALL_LETTER_Z_WITH_CARON		0xD8
#define Z_DOS_CP775_BOX_DRAWINGS_LIGHT_UP_AND_LEFT		0xD9
#define Z_DOS_CP775_BOX_DRAWINGS_LIGHT_DOWN_AND_RIGHT		0xDA
#define Z_DOS_CP775_FULL_BLOCK					0xDB
#define Z_DOS_CP775_LOWER_HALF_BLOCK				0xDC
#define Z_DOS_CP775_LEFT_HALF_BLOCK				0xDD
#define Z_DOS_CP775_RIGHT_HALF_BLOCK				0xDE
#define Z_DOS_CP775_UPPER_HALF_BLOCK				0xDF
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_O_WITH_ACUTE		0xE0
#define Z_DOS_CP775_LATIN_SMALL_LETTER_SHARP_S			0xE1
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_O_WITH_MACRON		0xE2
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_N_WITH_ACUTE		0xE3
#define Z_DOS_CP775_LATIN_SMALL_LETTER_O_WITH_TILDE		0xE4
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_O_WITH_TILDE		0xE5
#define Z_DOS_CP775_MICRO_SIGN					0xE6
#define Z_DOS_CP775_LATIN_SMALL_LETTER_N_WITH_ACUTE		0xE7
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_K_WITH_CEDILLA		0xE8
#define Z_DOS_CP775_LATIN_SMALL_LETTER_K_WITH_CEDILLA		0xE9
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_L_WITH_CEDILLA		0xEA
#define Z_DOS_CP775_LATIN_SMALL_LETTER_L_WITH_CEDILLA		0xEB
#define Z_DOS_CP775_LATIN_SMALL_LETTER_N_WITH_CEDILLA		0xEC
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_E_WITH_MACRON		0xED
#define Z_DOS_CP775_LATIN_CAPITAL_LETTER_N_WITH_CEDILLA		0xEE
#define Z_DOS_CP775_RIGHT_SINGLE_QUOTATION_MARK			0xEF
#define Z_DOS_CP775_SOFT_HYPHEN					0xF0
#define Z_DOS_CP775_PLUS_MINUS_SIGN				0xF1
#define Z_DOS_CP775_LEFT_DOUBLE_QUOTATION_MARK			0xF2
#define Z_DOS_CP775_VULGAR_FRACTION_THREE_QUARTERS		0xF3
#define Z_DOS_CP775_PILCROW_SIGN				0xF4
#define Z_DOS_CP775_SECTION_SIGN				0xF5
#define Z_DOS_CP775_DIVISION_SIGN				0xF6
#define Z_DOS_CP775_DOUBLE_LOW_9_QUOTATION_MARK			0xF7
#define Z_DOS_CP775_DEGREE_SIGN					0xF8
#define Z_DOS_CP775_BULLET_OPERATOR				0xF9
#define Z_DOS_CP775_MIDDLE_DOT					0xFA
#define Z_DOS_CP775_SUPERSCRIPT_ONE				0xFB
#define Z_DOS_CP775_SUPERSCRIPT_THREE				0xFC
#define Z_DOS_CP775_SUPERSCRIPT_TWO				0xFD
#define Z_DOS_CP775_BLACK_SQUARE				0xFE
#define Z_DOS_CP775_NO_BREAK_SPACE				0xFF

#define Z_ARRAY_CONTENT_DOS_CP775_TO_UNICODE(_)					\
	_(0106), _(00FC), _(00E9), _(0101), _(00E4), _(0123), _(00E5), _(0107), \
	_(0142), _(0113), _(0156), _(0157), _(012B), _(0179), _(00C4), _(00C5), \
	_(00C9), _(00E6), _(00C6), _(014D), _(00F6), _(0122), _(00A2), _(015A), \
	_(015B), _(00D6), _(00DC), _(00F8), _(00A3), _(00D8), _(00D7), _(00A4), \
	_(0100), _(012A), _(00F3), _(017B), _(017C), _(017A), _(201D), _(00A6), \
	_(00A9), _(00AE), _(00AC), _(00BD), _(00BC), _(0141), _(00AB), _(00BB), \
	_(2591), _(2592), _(2593), _(2502), _(2524), _(0104), _(010C), _(0118), \
	_(0116), _(2563), _(2551), _(2557), _(255D), _(012E), _(0160), _(2510), \
	_(2514), _(2534), _(252C), _(251C), _(2500), _(253C), _(0172), _(016A), \
	_(255A), _(2554), _(2569), _(2566), _(2560), _(2550), _(256C), _(017D), \
	_(0105), _(010D), _(0119), _(0117), _(012F), _(0161), _(0173), _(016B), \
	_(017E), _(2518), _(250C), _(2588), _(2584), _(258C), _(2590), _(2580), \
	_(00D3), _(00DF), _(014C), _(0143), _(00F5), _(00D5), _(00B5), _(0144), \
	_(0136), _(0137), _(013B), _(013C), _(0146), _(0112), _(0145), _(2019), \
	_(00AD), _(00B1), _(201C), _(00BE), _(00B6), _(00A7), _(00F7), _(201E), \
	_(00B0), _(2219), _(00B7), _(00B9), _(00B3), _(00B2), _(25A0), _(00A0)

#endif /* Z_formats_character_set_DOS_CP775_H */
