/* Zeta API - Z/formats/character set/DOS CP852.h
 ______ ____________  ___
|__   /|  ___|__  __|/   \
  /  /_|  __|  |  | /  *  \
 /_____|_____| |__|/__/ \__\
Copyright (C) 2006-2022 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef Z_formats_character_set_DOS_CP852_H
#define Z_formats_character_set_DOS_CP852_H

/* From 00h to 7Fh like ASCII */
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_C_WITH_CEDILLA		0x80
#define Z_DOS_CP852_LATIN_SMALL_LETTER_U_WITH_DIAERESIS		0x81
#define Z_DOS_CP852_LATIN_SMALL_LETTER_E_WITH_ACUTE		0x82
#define Z_DOS_CP852_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX	0x83
#define Z_DOS_CP852_LATIN_SMALL_LETTER_A_WITH_DIAERESIS		0x84
#define Z_DOS_CP852_LATIN_SMALL_LETTER_U_WITH_RING_ABOVE	0x85
#define Z_DOS_CP852_LATIN_SMALL_LETTER_C_WITH_ACUTE		0x86
#define Z_DOS_CP852_LATIN_SMALL_LETTER_C_WITH_CEDILLA		0x87
#define Z_DOS_CP852_LATIN_SMALL_LETTER_L_WITH_STROKE		0x88
#define Z_DOS_CP852_LATIN_SMALL_LETTER_E_WITH_DIAERESIS		0x89
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_O_WITH_DOUBLE_ACUTE	0x8A
#define Z_DOS_CP852_LATIN_SMALL_LETTER_O_WITH_DOUBLE_ACUTE	0x8B
#define Z_DOS_CP852_LATIN_SMALL_LETTER_I_WITH_CIRCUMFLEX	0x8C
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_Z_WITH_ACUTE		0x8D
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_A_WITH_DIAERESIS	0x8E
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_C_WITH_ACUTE		0x8F
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_E_WITH_ACUTE		0x90
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_L_WITH_ACUTE		0x91
#define Z_DOS_CP852_LATIN_SMALL_LETTER_L_WITH_ACUTE		0x92
#define Z_DOS_CP852_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX	0x93
#define Z_DOS_CP852_LATIN_SMALL_LETTER_O_WITH_DIAERESIS		0x94
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_L_WITH_CARON		0x95
#define Z_DOS_CP852_LATIN_SMALL_LETTER_L_WITH_CARON		0x96
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_S_WITH_ACUTE		0x97
#define Z_DOS_CP852_LATIN_SMALL_LETTER_S_WITH_ACUTE		0x98
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_O_WITH_DIAERESIS	0x99
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS	0x9A
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_T_WITH_CARON		0x9B
#define Z_DOS_CP852_LATIN_SMALL_LETTER_T_WITH_CARON		0x9C
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_L_WITH_STROKE		0x9D
#define Z_DOS_CP852_MULTIPLICATION_SIGN				0x9E
#define Z_DOS_CP852_LATIN_SMALL_LETTER_C_WITH_CARON		0x9F
#define Z_DOS_CP852_LATIN_SMALL_LETTER_A_WITH_ACUTE		0xA0
#define Z_DOS_CP852_LATIN_SMALL_LETTER_I_WITH_ACUTE		0xA1
#define Z_DOS_CP852_LATIN_SMALL_LETTER_O_WITH_ACUTE		0xA2
#define Z_DOS_CP852_LATIN_SMALL_LETTER_U_WITH_ACUTE		0xA3
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_A_WITH_OGONEK		0xA4
#define Z_DOS_CP852_LATIN_SMALL_LETTER_A_WITH_OGONEK		0xA5
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_Z_WITH_CARON		0xA6
#define Z_DOS_CP852_LATIN_SMALL_LETTER_Z_WITH_CARON		0xA7
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_E_WITH_OGONEK		0xA8
#define Z_DOS_CP852_LATIN_SMALL_LETTER_E_WITH_OGONEK		0xA9
#define Z_DOS_CP852_NOT_SIGN					0xAA
#define Z_DOS_CP852_LATIN_SMALL_LETTER_Z_WITH_ACUTE		0xAB
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_C_WITH_CARON		0xAC
#define Z_DOS_CP852_LATIN_SMALL_LETTER_S_WITH_CEDILLA		0xAD
#define Z_DOS_CP852_LEFT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK	0xAE
#define Z_DOS_CP852_RIGHT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK	0xAF
#define Z_DOS_CP852_LIGHT_SHADE					0xB0
#define Z_DOS_CP852_MEDIUM_SHADE				0xB1
#define Z_DOS_CP852_DARK_SHADE					0xB2
#define Z_DOS_CP852_BOX_DRAWINGS_LIGHT_VERTICAL			0xB3
#define Z_DOS_CP852_BOX_DRAWINGS_LIGHT_VERTICAL_AND_LEFT	0xB4
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_A_WITH_ACUTE		0xB5
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX	0xB6
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_E_WITH_CARON		0xB7
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_S_WITH_CEDILLA		0xB8
#define Z_DOS_CP852_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_LEFT	0xB9
#define Z_DOS_CP852_BOX_DRAWINGS_DOUBLE_VERTICAL		0xBA
#define Z_DOS_CP852_BOX_DRAWINGS_DOUBLE_DOWN_AND_LEFT		0xBB
#define Z_DOS_CP852_BOX_DRAWINGS_DOUBLE_UP_AND_LEFT		0xBC
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_Z_WITH_DOT_ABOVE	0xBD
#define Z_DOS_CP852_LATIN_SMALL_LETTER_Z_WITH_DOT_ABOVE		0xBE
#define Z_DOS_CP852_BOX_DRAWINGS_LIGHT_DOWN_AND_LEFT		0xBF
#define Z_DOS_CP852_BOX_DRAWINGS_LIGHT_UP_AND_RIGHT		0xC0
#define Z_DOS_CP852_BOX_DRAWINGS_LIGHT_UP_AND_HORIZONTAL	0xC1
#define Z_DOS_CP852_BOX_DRAWINGS_LIGHT_DOWN_AND_HORIZONTAL	0xC2
#define Z_DOS_CP852_BOX_DRAWINGS_LIGHT_VERTICAL_AND_RIGHT	0xC3
#define Z_DOS_CP852_BOX_DRAWINGS_LIGHT_HORIZONTAL		0xC4
#define Z_DOS_CP852_BOX_DRAWINGS_LIGHT_VERTICAL_AND_HORIZONTAL	0xC5
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_A_WITH_BREVE		0xC6
#define Z_DOS_CP852_LATIN_SMALL_LETTER_A_WITH_BREVE		0xC7
#define Z_DOS_CP852_BOX_DRAWINGS_DOUBLE_UP_AND_RIGHT		0xC8
#define Z_DOS_CP852_BOX_DRAWINGS_DOUBLE_DOWN_AND_RIGHT		0xC9
#define Z_DOS_CP852_BOX_DRAWINGS_DOUBLE_UP_AND_HORIZONTAL	0xCA
#define Z_DOS_CP852_BOX_DRAWINGS_DOUBLE_DOWN_AND_HORIZONTAL	0xCB
#define Z_DOS_CP852_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_RIGHT	0xCC
#define Z_DOS_CP852_BOX_DRAWINGS_DOUBLE_HORIZONTAL		0xCD
#define Z_DOS_CP852_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_HORIZONTAL	0xCE
#define Z_DOS_CP852_CURRENCY_SIGN				0xCF
#define Z_DOS_CP852_LATIN_SMALL_LETTER_D_WITH_STROKE		0xD0
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_D_WITH_STROKE		0xD1
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_D_WITH_CARON		0xD2
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_E_WITH_DIAERESIS	0xD3
#define Z_DOS_CP852_LATIN_SMALL_LETTER_D_WITH_CARON		0xD4
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_N_WITH_CARON		0xD5
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_I_WITH_ACUTE		0xD6
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_I_WITH_CIRCUMFLEX	0xD7
#define Z_DOS_CP852_LATIN_SMALL_LETTER_E_WITH_CARON		0xD8
#define Z_DOS_CP852_BOX_DRAWINGS_LIGHT_UP_AND_LEFT		0xD9
#define Z_DOS_CP852_BOX_DRAWINGS_LIGHT_DOWN_AND_RIGHT		0xDA
#define Z_DOS_CP852_FULL_BLOCK					0xDB
#define Z_DOS_CP852_LOWER_HALF_BLOCK				0xDC
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_T_WITH_CEDILLA		0xDD
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_U_WITH_RING_ABOVE	0xDE
#define Z_DOS_CP852_UPPER_HALF_BLOCK				0xDF
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_O_WITH_ACUTE		0xE0
#define Z_DOS_CP852_LATIN_SMALL_LETTER_SHARP_S			0xE1
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX	0xE2
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_N_WITH_ACUTE		0xE3
#define Z_DOS_CP852_LATIN_SMALL_LETTER_N_WITH_ACUTE		0xE4
#define Z_DOS_CP852_LATIN_SMALL_LETTER_N_WITH_CARON		0xE5
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_S_WITH_CARON		0xE6
#define Z_DOS_CP852_LATIN_SMALL_LETTER_S_WITH_CARON		0xE7
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_R_WITH_ACUTE		0xE8
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_U_WITH_ACUTE		0xE9
#define Z_DOS_CP852_LATIN_SMALL_LETTER_R_WITH_ACUTE		0xEA
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_U_WITH_DOUBLE_ACUTE	0xEB
#define Z_DOS_CP852_LATIN_SMALL_LETTER_Y_WITH_ACUTE		0xEC
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_Y_WITH_ACUTE		0xED
#define Z_DOS_CP852_LATIN_SMALL_LETTER_T_WITH_CEDILLA		0xEE
#define Z_DOS_CP852_ACUTE_ACCENT				0xEF
#define Z_DOS_CP852_SOFT_HYPHEN					0xF0
#define Z_DOS_CP852_DOUBLE_ACUTE_ACCENT				0xF1
#define Z_DOS_CP852_OGONEK					0xF2
#define Z_DOS_CP852_CARON					0xF3
#define Z_DOS_CP852_BREVE					0xF4
#define Z_DOS_CP852_SECTION_SIGN				0xF5
#define Z_DOS_CP852_DIVISION_SIGN				0xF6
#define Z_DOS_CP852_CEDILLA					0xF7
#define Z_DOS_CP852_DEGREE_SIGN					0xF8
#define Z_DOS_CP852_DIAERESIS					0xF9
#define Z_DOS_CP852_DOT_ABOVE					0xFA
#define Z_DOS_CP852_LATIN_SMALL_LETTER_U_WITH_DOUBLE_ACUTE	0xFB
#define Z_DOS_CP852_LATIN_CAPITAL_LETTER_R_WITH_CARON		0xFC
#define Z_DOS_CP852_LATIN_SMALL_LETTER_R_WITH_CARON		0xFD
#define Z_DOS_CP852_BLACK_SQUARE				0xFE
#define Z_DOS_CP852_NO_BREAK_SPACE				0xFF

#define Z_ARRAY_CONTENT_DOS_CP852_TO_UNICODE(_)					\
	_(00C7), _(00FC), _(00E9), _(00E2), _(00E4), _(016F), _(0107), _(00E7), \
	_(0142), _(00EB), _(0150), _(0151), _(00EE), _(0179), _(00C4), _(0106), \
	_(00C9), _(0139), _(013A), _(00F4), _(00F6), _(013D), _(013E), _(015A), \
	_(015B), _(00D6), _(00DC), _(0164), _(0165), _(0141), _(00D7), _(010D), \
	_(00E1), _(00ED), _(00F3), _(00FA), _(0104), _(0105), _(017D), _(017E), \
	_(0118), _(0119), _(00AC), _(017A), _(010C), _(015F), _(00AB), _(00BB), \
	_(2591), _(2592), _(2593), _(2502), _(2524), _(00C1), _(00C2), _(011A), \
	_(015E), _(2563), _(2551), _(2557), _(255D), _(017B), _(017C), _(2510), \
	_(2514), _(2534), _(252C), _(251C), _(2500), _(253C), _(0102), _(0103), \
	_(255A), _(2554), _(2569), _(2566), _(2560), _(2550), _(256C), _(00A4), \
	_(0111), _(0110), _(010E), _(00CB), _(010F), _(0147), _(00CD), _(00CE), \
	_(011B), _(2518), _(250C), _(2588), _(2584), _(0162), _(016E), _(2580), \
	_(00D3), _(00DF), _(00D4), _(0143), _(0144), _(0148), _(0160), _(0161), \
	_(0154), _(00DA), _(0155), _(0170), _(00FD), _(00DD), _(0163), _(00B4), \
	_(00AD), _(02DD), _(02DB), _(02C7), _(02D8), _(00A7), _(00F7), _(00B8), \
	_(00B0), _(00A8), _(02D9), _(0171), _(0158), _(0159), _(25A0), _(00A0)

#endif /* Z_formats_character_set_DOS_CP852_H */
