/* Zeta API - Z/formats/character set/DOS CP869.h
 ______ ____________  ___
|__   /|  ___|__  __|/   \
  /  /_|  __|  |  | /  *  \
 /_____|_____| |__|/__/ \__\
Copyright (C) 2006-2022 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef Z_formats_character_set_DOS_CP869_H
#define Z_formats_character_set_DOS_CP869_H

/* From 00h to 7Fh like ASCII */
/* 80h undefined */
/* 81h undefined */
/* 82h undefined */
/* 83h undefined */
/* 84h undefined */
/* 85h undefined */
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_ALPHA_WITH_TONOS		0x86
/* 87h undefined */
#define Z_DOS_CP869_MIDDLE_DOT						0x88
#define Z_DOS_CP869_NOT_SIGN						0x89
#define Z_DOS_CP869_BROKEN_BAR						0x8A
#define Z_DOS_CP869_LEFT_SINGLE_QUOTATION_MARK				0x8B
#define Z_DOS_CP869_RIGHT_SINGLE_QUOTATION_MARK				0x8C
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_EPSILON_WITH_TONOS		0x8D
#define Z_DOS_CP869_HORIZONTAL_BAR					0x8E
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_ETA_WITH_TONOS			0x8F
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_IOTA_WITH_TONOS		0x90
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_IOTA_WITH_DIALYTIKA		0x91
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_OMICRON_WITH_TONOS		0x92
/* 93h undefined */
/* 94h undefined */
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_UPSILON_WITH_TONOS		0x95
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_UPSILON_WITH_DIALYTIKA		0x96
#define Z_DOS_CP869_COPYRIGHT_SIGN					0x97
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_OMEGA_WITH_TONOS		0x98
#define Z_DOS_CP869_SUPERSCRIPT_TWO					0x99
#define Z_DOS_CP869_SUPERSCRIPT_THREE					0x9A
#define Z_DOS_CP869_GREEK_SMALL_LETTER_ALPHA_WITH_TONOS			0x9B
#define Z_DOS_CP869_POUND_SIGN						0x9C
#define Z_DOS_CP869_GREEK_SMALL_LETTER_EPSILON_WITH_TONOS		0x9D
#define Z_DOS_CP869_GREEK_SMALL_LETTER_ETA_WITH_TONOS			0x9E
#define Z_DOS_CP869_GREEK_SMALL_LETTER_IOTA_WITH_TONOS			0x9F
#define Z_DOS_CP869_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA		0xA0
#define Z_DOS_CP869_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_TONOS	0xA1
#define Z_DOS_CP869_GREEK_SMALL_LETTER_OMICRON_WITH_TONOS		0xA2
#define Z_DOS_CP869_GREEK_SMALL_LETTER_UPSILON_WITH_TONOS		0xA3
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_ALPHA				0xA4
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_BETA				0xA5
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_GAMMA				0xA6
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_DELTA				0xA7
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_EPSILON			0xA8
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_ZETA				0xA9
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_ETA				0xAA
#define Z_DOS_CP869_VULGAR_FRACTION_ONE_HALF				0xAB
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_THETA				0xAC
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_IOTA				0xAD
#define Z_DOS_CP869_LEFT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK		0xAE
#define Z_DOS_CP869_RIGHT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK		0xAF
#define Z_DOS_CP869_LIGHT_SHADE						0xB0
#define Z_DOS_CP869_MEDIUM_SHADE					0xB1
#define Z_DOS_CP869_DARK_SHADE						0xB2
#define Z_DOS_CP869_BOX_DRAWINGS_LIGHT_VERTICAL				0xB3
#define Z_DOS_CP869_BOX_DRAWINGS_LIGHT_VERTICAL_AND_LEFT		0xB4
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_KAPPA				0xB5
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_LAMDA				0xB6
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_MU				0xB7
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_NU				0xB8
#define Z_DOS_CP869_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_LEFT		0xB9
#define Z_DOS_CP869_BOX_DRAWINGS_DOUBLE_VERTICAL			0xBA
#define Z_DOS_CP869_BOX_DRAWINGS_DOUBLE_DOWN_AND_LEFT			0xBB
#define Z_DOS_CP869_BOX_DRAWINGS_DOUBLE_UP_AND_LEFT			0xBC
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_XI				0xBD
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_OMICRON			0xBE
#define Z_DOS_CP869_BOX_DRAWINGS_LIGHT_DOWN_AND_LEFT			0xBF
#define Z_DOS_CP869_BOX_DRAWINGS_LIGHT_UP_AND_RIGHT			0xC0
#define Z_DOS_CP869_BOX_DRAWINGS_LIGHT_UP_AND_HORIZONTAL		0xC1
#define Z_DOS_CP869_BOX_DRAWINGS_LIGHT_DOWN_AND_HORIZONTAL		0xC2
#define Z_DOS_CP869_BOX_DRAWINGS_LIGHT_VERTICAL_AND_RIGHT		0xC3
#define Z_DOS_CP869_BOX_DRAWINGS_LIGHT_HORIZONTAL			0xC4
#define Z_DOS_CP869_BOX_DRAWINGS_LIGHT_VERTICAL_AND_HORIZONTAL		0xC5
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_PI				0xC6
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_RHO				0xC7
#define Z_DOS_CP869_BOX_DRAWINGS_DOUBLE_UP_AND_RIGHT			0xC8
#define Z_DOS_CP869_BOX_DRAWINGS_DOUBLE_DOWN_AND_RIGHT			0xC9
#define Z_DOS_CP869_BOX_DRAWINGS_DOUBLE_UP_AND_HORIZONTAL		0xCA
#define Z_DOS_CP869_BOX_DRAWINGS_DOUBLE_DOWN_AND_HORIZONTAL		0xCB
#define Z_DOS_CP869_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_RIGHT		0xCC
#define Z_DOS_CP869_BOX_DRAWINGS_DOUBLE_HORIZONTAL			0xCD
#define Z_DOS_CP869_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_HORIZONTAL		0xCE
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_SIGMA				0xCF
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_TAU				0xD0
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_UPSILON			0xD1
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_PHI				0xD2
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_CHI				0xD3
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_PSI				0xD4
#define Z_DOS_CP869_GREEK_CAPITAL_LETTER_OMEGA				0xD5
#define Z_DOS_CP869_GREEK_SMALL_LETTER_ALPHA				0xD6
#define Z_DOS_CP869_GREEK_SMALL_LETTER_BETA				0xD7
#define Z_DOS_CP869_GREEK_SMALL_LETTER_GAMMA				0xD8
#define Z_DOS_CP869_BOX_DRAWINGS_LIGHT_UP_AND_LEFT			0xD9
#define Z_DOS_CP869_BOX_DRAWINGS_LIGHT_DOWN_AND_RIGHT			0xDA
#define Z_DOS_CP869_FULL_BLOCK						0xDB
#define Z_DOS_CP869_LOWER_HALF_BLOCK					0xDC
#define Z_DOS_CP869_GREEK_SMALL_LETTER_DELTA				0xDD
#define Z_DOS_CP869_GREEK_SMALL_LETTER_EPSILON				0xDE
#define Z_DOS_CP869_UPPER_HALF_BLOCK					0xDF
#define Z_DOS_CP869_GREEK_SMALL_LETTER_ZETA				0xE0
#define Z_DOS_CP869_GREEK_SMALL_LETTER_ETA				0xE1
#define Z_DOS_CP869_GREEK_SMALL_LETTER_THETA				0xE2
#define Z_DOS_CP869_GREEK_SMALL_LETTER_IOTA				0xE3
#define Z_DOS_CP869_GREEK_SMALL_LETTER_KAPPA				0xE4
#define Z_DOS_CP869_GREEK_SMALL_LETTER_LAMDA				0xE5
#define Z_DOS_CP869_GREEK_SMALL_LETTER_MU				0xE6
#define Z_DOS_CP869_GREEK_SMALL_LETTER_NU				0xE7
#define Z_DOS_CP869_GREEK_SMALL_LETTER_XI				0xE8
#define Z_DOS_CP869_GREEK_SMALL_LETTER_OMICRON				0xE9
#define Z_DOS_CP869_GREEK_SMALL_LETTER_PI				0xEA
#define Z_DOS_CP869_GREEK_SMALL_LETTER_RHO				0xEB
#define Z_DOS_CP869_GREEK_SMALL_LETTER_SIGMA				0xEC
#define Z_DOS_CP869_GREEK_SMALL_LETTER_FINAL_SIGMA			0xED
#define Z_DOS_CP869_GREEK_SMALL_LETTER_TAU				0xEE
#define Z_DOS_CP869_GREEK_TONOS						0xEF
#define Z_DOS_CP869_SOFT_HYPHEN						0xF0
#define Z_DOS_CP869_PLUS_MINUS_SIGN					0xF1
#define Z_DOS_CP869_GREEK_SMALL_LETTER_UPSILON				0xF2
#define Z_DOS_CP869_GREEK_SMALL_LETTER_PHI				0xF3
#define Z_DOS_CP869_GREEK_SMALL_LETTER_CHI				0xF4
#define Z_DOS_CP869_SECTION_SIGN					0xF5
#define Z_DOS_CP869_GREEK_SMALL_LETTER_PSI				0xF6
#define Z_DOS_CP869_GREEK_DIALYTIKA_TONOS				0xF7
#define Z_DOS_CP869_DEGREE_SIGN						0xF8
#define Z_DOS_CP869_DIAERESIS						0xF9
#define Z_DOS_CP869_GREEK_SMALL_LETTER_OMEGA				0xFA
#define Z_DOS_CP869_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA		0xFB
#define Z_DOS_CP869_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_TONOS	0xFC
#define Z_DOS_CP869_GREEK_SMALL_LETTER_OMEGA_WITH_TONOS			0xFD
#define Z_DOS_CP869_BLACK_SQUARE					0xFE
#define Z_DOS_CP869_NO_BREAK_SPACE					0xFF

#define Z_ARRAY_CONTENT_DOS_CP869_TO_UNICODE(_, undefined)				      \
	undefined, undefined, undefined, undefined, undefined, undefined, _(0386), undefined, \
	_(00B7),   _(00AC),   _(00A6),	 _(2018),   _(2019),   _(0388),	  _(2015), _(0389),   \
	_(038A),   _(03AA),   _(038C),	 undefined, undefined, _(038E),	  _(03AB), _(00A9),   \
	_(038F),   _(00B2),   _(00B3),	 _(03AC),   _(00A3),   _(03AD),	  _(03AE), _(03AF),   \
	_(03CA),   _(0390),   _(03CC),	 _(03CD),   _(0391),   _(0392),	  _(0393), _(0394),   \
	_(0395),   _(0396),   _(0397),	 _(00BD),   _(0398),   _(0399),	  _(00AB), _(00BB),   \
	_(2591),   _(2592),   _(2593),	 _(2502),   _(2524),   _(039A),	  _(039B), _(039C),   \
	_(039D),   _(2563),   _(2551),	 _(2557),   _(255D),   _(039E),	  _(039F), _(2510),   \
	_(2514),   _(2534),   _(252C),	 _(251C),   _(2500),   _(253C),	  _(03A0), _(03A1),   \
	_(255A),   _(2554),   _(2569),	 _(2566),   _(2560),   _(2550),	  _(256C), _(03A3),   \
	_(03A4),   _(03A5),   _(03A6),	 _(03A7),   _(03A8),   _(03A9),	  _(03B1), _(03B2),   \
	_(03B3),   _(2518),   _(250C),	 _(2588),   _(2584),   _(03B4),	  _(03B5), _(2580),   \
	_(03B6),   _(03B7),   _(03B8),	 _(03B9),   _(03BA),   _(03BB),	  _(03BC), _(03BD),   \
	_(03BE),   _(03BF),   _(03C0),	 _(03C1),   _(03C3),   _(03C2),	  _(03C4), _(0384),   \
	_(00AD),   _(00B1),   _(03C5),	 _(03C6),   _(03C7),   _(00A7),	  _(03C8), _(0385),   \
	_(00B0),   _(00A8),   _(03C9),	 _(03CB),   _(03B0),   _(03CE),	  _(25A0), _(00A0)

#endif /* Z_formats_character_set_DOS_CP869_H */
