/* Zeta API - Z/formats/character set/DOS CP872.h
 ______ ____________  ___
|__   /|  ___|__  __|/   \
  /  /_|  __|  |  | /  *  \
 /_____|_____| |__|/__/ \__\
Copyright (C) 2006-2022 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef Z_formats_character_set_DOS_CP872_H
#define Z_formats_character_set_DOS_CP872_H

/* From 00h to 7Fh like ASCII */
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_DJE			     0x80
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_DJE			     0x81
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_GJE			     0x82
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_GJE			     0x83
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_IO			     0x84
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_IO			     0x85
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_UKRAINIAN_IE		     0x86
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_UKRAINIAN_IE	     0x87
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_DZE			     0x88
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_DZE			     0x89
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_BYELORUSSIAN_UKRAINIAN_I   0x8A
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_BYELORUSSIAN_UKRAINIAN_I 0x8B
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_YI			     0x8C
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_YI			     0x8D
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_JE			     0x8E
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_JE			     0x8F
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_LJE			     0x90
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_LJE			     0x91
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_NJE			     0x92
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_NJE			     0x93
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_TSHE			     0x94
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_TSHE		     0x95
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_KJE			     0x96
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_KJE			     0x97
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_SHORT_U		     0x98
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_SHORT_U		     0x99
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_DZHE			     0x9A
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_DZHE		     0x9B
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_YU			     0x9C
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_YU			     0x9D
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_HARD_SIGN		     0x9E
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_HARD_SIGN		     0x9F
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_A			     0xA0
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_A			     0xA1
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_BE			     0xA2
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_BE			     0xA3
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_TSE			     0xA4
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_TSE			     0xA5
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_DE			     0xA6
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_DE			     0xA7
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_IE			     0xA8
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_IE			     0xA9
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_EF			     0xAA
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_EF			     0xAB
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_GHE			     0xAC
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_GHE			     0xAD
#define Z_DOS_CP872_LEFT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK	     0xAE
#define Z_DOS_CP872_RIGHT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK	     0xAF
#define Z_DOS_CP872_LIGHT_SHADE					     0xB0
#define Z_DOS_CP872_MEDIUM_SHADE				     0xB1
#define Z_DOS_CP872_DARK_SHADE					     0xB2
#define Z_DOS_CP872_BOX_DRAWINGS_LIGHT_VERTICAL			     0xB3
#define Z_DOS_CP872_BOX_DRAWINGS_LIGHT_VERTICAL_AND_LEFT	     0xB4
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_HA			     0xB5
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_HA			     0xB6
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_I			     0xB7
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_I			     0xB8
#define Z_DOS_CP872_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_LEFT	     0xB9
#define Z_DOS_CP872_BOX_DRAWINGS_DOUBLE_VERTICAL		     0xBA
#define Z_DOS_CP872_BOX_DRAWINGS_DOUBLE_DOWN_AND_LEFT		     0xBB
#define Z_DOS_CP872_BOX_DRAWINGS_DOUBLE_UP_AND_LEFT		     0xBC
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_SHORT_I		     0xBD
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_SHORT_I		     0xBE
#define Z_DOS_CP872_BOX_DRAWINGS_LIGHT_DOWN_AND_LEFT		     0xBF
#define Z_DOS_CP872_BOX_DRAWINGS_LIGHT_UP_AND_RIGHT		     0xC0
#define Z_DOS_CP872_BOX_DRAWINGS_LIGHT_UP_AND_HORIZONTAL	     0xC1
#define Z_DOS_CP872_BOX_DRAWINGS_LIGHT_DOWN_AND_HORIZONTAL	     0xC2
#define Z_DOS_CP872_BOX_DRAWINGS_LIGHT_VERTICAL_AND_RIGHT	     0xC3
#define Z_DOS_CP872_BOX_DRAWINGS_LIGHT_HORIZONTAL		     0xC4
#define Z_DOS_CP872_BOX_DRAWINGS_LIGHT_VERTICAL_AND_HORIZONTAL	     0xC5
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_KA			     0xC6
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_KA			     0xC7
#define Z_DOS_CP872_BOX_DRAWINGS_DOUBLE_UP_AND_RIGHT		     0xC8
#define Z_DOS_CP872_BOX_DRAWINGS_DOUBLE_DOWN_AND_RIGHT		     0xC9
#define Z_DOS_CP872_BOX_DRAWINGS_DOUBLE_UP_AND_HORIZONTAL	     0xCA
#define Z_DOS_CP872_BOX_DRAWINGS_DOUBLE_DOWN_AND_HORIZONTAL	     0xCB
#define Z_DOS_CP872_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_RIGHT	     0xCC
#define Z_DOS_CP872_BOX_DRAWINGS_DOUBLE_HORIZONTAL		     0xCD
#define Z_DOS_CP872_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_HORIZONTAL	     0xCE
#define Z_DOS_CP872_EURO_SIGN					     0xCF
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_EL			     0xD0
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_EL			     0xD1
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_EM			     0xD2
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_EM			     0xD3
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_EN			     0xD4
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_EN			     0xD5
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_O			     0xD6
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_O			     0xD7
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_PE			     0xD8
#define Z_DOS_CP872_BOX_DRAWINGS_LIGHT_UP_AND_LEFT		     0xD9
#define Z_DOS_CP872_BOX_DRAWINGS_LIGHT_DOWN_AND_RIGHT		     0xDA
#define Z_DOS_CP872_FULL_BLOCK					     0xDB
#define Z_DOS_CP872_LOWER_HALF_BLOCK				     0xDC
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_PE			     0xDD
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_YA			     0xDE
#define Z_DOS_CP872_UPPER_HALF_BLOCK				     0xDF
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_YA			     0xE0
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_ER			     0xE1
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_ER			     0xE2
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_ES			     0xE3
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_ES			     0xE4
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_TE			     0xE5
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_TE			     0xE6
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_U			     0xE7
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_U			     0xE8
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_ZHE			     0xE9
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_ZHE			     0xEA
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_VE			     0xEB
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_VE			     0xEC
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_SOFT_SIGN		     0xED
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_SOFT_SIGN		     0xEE
#define Z_DOS_CP872_NUMERO_SIGN					     0xEF
#define Z_DOS_CP872_SOFT_HYPHEN					     0xF0
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_YERU			     0xF1
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_YERU		     0xF2
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_ZE			     0xF3
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_ZE			     0xF4
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_SHA			     0xF5
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_SHA			     0xF6
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_E			     0xF7
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_E			     0xF8
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_SHCHA			     0xF9
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_SHCHA		     0xFA
#define Z_DOS_CP872_CYRILLIC_SMALL_LETTER_CHE			     0xFB
#define Z_DOS_CP872_CYRILLIC_CAPITAL_LETTER_CHE			     0xFC
#define Z_DOS_CP872_SECTION_SIGN				     0xFD
#define Z_DOS_CP872_BLACK_SQUARE				     0xFE
#define Z_DOS_CP872_NO_BREAK_SPACE				     0xFF

#define Z_ARRAY_CONTENT_DOS_CP872_TO_UNICODE(_)					\
	_(0452), _(0402), _(0453), _(0403), _(0451), _(0401), _(0454), _(0404), \
	_(0455), _(0405), _(0456), _(0406), _(0457), _(0407), _(0458), _(0408), \
	_(0459), _(0409), _(045A), _(040A), _(045B), _(040B), _(045C), _(040C), \
	_(045E), _(040E), _(045F), _(040F), _(044E), _(042E), _(044A), _(042A), \
	_(0430), _(0410), _(0431), _(0411), _(0446), _(0426), _(0434), _(0414), \
	_(0435), _(0415), _(0444), _(0424), _(0433), _(0413), _(00AB), _(00BB), \
	_(2591), _(2592), _(2593), _(2502), _(2524), _(0445), _(0425), _(0438), \
	_(0418), _(2563), _(2551), _(2557), _(255D), _(0439), _(0419), _(2510), \
	_(2514), _(2534), _(252C), _(251C), _(2500), _(253C), _(043A), _(041A), \
	_(255A), _(2554), _(2569), _(2566), _(2560), _(2550), _(256C), _(20AC), \
	_(043B), _(041B), _(043C), _(041C), _(043D), _(041D), _(043E), _(041E), \
	_(043F), _(2518), _(250C), _(2588), _(2584), _(041F), _(044F), _(2580), \
	_(042F), _(0440), _(0420), _(0441), _(0421), _(0442), _(0422), _(0443), \
	_(0423), _(0436), _(0416), _(0432), _(0412), _(044C), _(042C), _(2116), \
	_(00AD), _(044B), _(042B), _(0437), _(0417), _(0448), _(0428), _(044D), \
	_(042D), _(0449), _(0429), _(0447), _(0427), _(00A7), _(25A0), _(00A0)

#endif /* Z_formats_character_set_DOS_CP872_H */
