/* Zeta API - Z/formats/character set/DOS CP874.h
 ______ ____________  ___
|__   /|  ___|__  __|/   \
  /  /_|  __|  |  | /  *  \
 /_____|_____| |__|/__/ \__\
Copyright (C) 2006-2022 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef Z_formats_character_set_DOS_CP874_H
#define Z_formats_character_set_DOS_CP874_H

/* From 00h to 7Fh like ASCII */
#define Z_DOS_CP874_EURO_SIGN			    0x80
/* 81h undefined */
/* 82h undefined */
/* 83h undefined */
/* 84h undefined */
#define Z_DOS_CP874_HORIZONTAL_ELLIPSIS		    0x85
/* 86h undefined */
/* 87h undefined */
/* 88h undefined */
/* 89h undefined */
/* 8Ah undefined */
/* 8Bh undefined */
/* 8Ch undefined */
/* 8Dh undefined */
/* 8Eh undefined */
/* 8Fh undefined */
/* 90h undefined */
#define Z_DOS_CP874_LEFT_SINGLE_QUOTATION_MARK	    0x91
#define Z_DOS_CP874_RIGHT_SINGLE_QUOTATION_MARK	    0x92
#define Z_DOS_CP874_LEFT_DOUBLE_QUOTATION_MARK	    0x93
#define Z_DOS_CP874_RIGHT_DOUBLE_QUOTATION_MARK	    0x94
#define Z_DOS_CP874_BULLET			    0x95
#define Z_DOS_CP874_EN_DASH			    0x96
#define Z_DOS_CP874_EM_DASH			    0x97
/* 98h undefined */
/* 99h undefined */
/* 9Ah undefined */
/* 9Bh undefined */
/* 9Ch undefined */
/* 9Dh undefined */
/* 9Eh undefined */
/* 9Fh undefined */
#define Z_DOS_CP874_NO_BREAK_SPACE		    0xA0
#define Z_DOS_CP874_THAI_CHARACTER_KO_KAI	    0xA1
#define Z_DOS_CP874_THAI_CHARACTER_KHO_KHAI	    0xA2
#define Z_DOS_CP874_THAI_CHARACTER_KHO_KHUAT	    0xA3
#define Z_DOS_CP874_THAI_CHARACTER_KHO_KHWAI	    0xA4
#define Z_DOS_CP874_THAI_CHARACTER_KHO_KHON	    0xA5
#define Z_DOS_CP874_THAI_CHARACTER_KHO_RAKHANG	    0xA6
#define Z_DOS_CP874_THAI_CHARACTER_NGO_NGU	    0xA7
#define Z_DOS_CP874_THAI_CHARACTER_CHO_CHAN	    0xA8
#define Z_DOS_CP874_THAI_CHARACTER_CHO_CHING	    0xA9
#define Z_DOS_CP874_THAI_CHARACTER_CHO_CHANG	    0xAA
#define Z_DOS_CP874_THAI_CHARACTER_SO_SO	    0xAB
#define Z_DOS_CP874_THAI_CHARACTER_CHO_CHOE	    0xAC
#define Z_DOS_CP874_THAI_CHARACTER_YO_YING	    0xAD
#define Z_DOS_CP874_THAI_CHARACTER_DO_CHADA	    0xAE
#define Z_DOS_CP874_THAI_CHARACTER_TO_PATAK	    0xAF
#define Z_DOS_CP874_THAI_CHARACTER_THO_THAN	    0xB0
#define Z_DOS_CP874_THAI_CHARACTER_THO_NANGMONTHO   0xB1
#define Z_DOS_CP874_THAI_CHARACTER_THO_PHUTHAO	    0xB2
#define Z_DOS_CP874_THAI_CHARACTER_NO_NEN	    0xB3
#define Z_DOS_CP874_THAI_CHARACTER_DO_DEK	    0xB4
#define Z_DOS_CP874_THAI_CHARACTER_TO_TAO	    0xB5
#define Z_DOS_CP874_THAI_CHARACTER_THO_THUNG	    0xB6
#define Z_DOS_CP874_THAI_CHARACTER_THO_THAHAN	    0xB7
#define Z_DOS_CP874_THAI_CHARACTER_THO_THONG	    0xB8
#define Z_DOS_CP874_THAI_CHARACTER_NO_NU	    0xB9
#define Z_DOS_CP874_THAI_CHARACTER_BO_BAIMAI	    0xBA
#define Z_DOS_CP874_THAI_CHARACTER_PO_PLA	    0xBB
#define Z_DOS_CP874_THAI_CHARACTER_PHO_PHUNG	    0xBC
#define Z_DOS_CP874_THAI_CHARACTER_FO_FA	    0xBD
#define Z_DOS_CP874_THAI_CHARACTER_PHO_PHAN	    0xBE
#define Z_DOS_CP874_THAI_CHARACTER_FO_FAN	    0xBF
#define Z_DOS_CP874_THAI_CHARACTER_PHO_SAMPHAO	    0xC0
#define Z_DOS_CP874_THAI_CHARACTER_MO_MA	    0xC1
#define Z_DOS_CP874_THAI_CHARACTER_YO_YAK	    0xC2
#define Z_DOS_CP874_THAI_CHARACTER_RO_RUA	    0xC3
#define Z_DOS_CP874_THAI_CHARACTER_RU		    0xC4
#define Z_DOS_CP874_THAI_CHARACTER_LO_LING	    0xC5
#define Z_DOS_CP874_THAI_CHARACTER_LU		    0xC6
#define Z_DOS_CP874_THAI_CHARACTER_WO_WAEN	    0xC7
#define Z_DOS_CP874_THAI_CHARACTER_SO_SALA	    0xC8
#define Z_DOS_CP874_THAI_CHARACTER_SO_RUSI	    0xC9
#define Z_DOS_CP874_THAI_CHARACTER_SO_SUA	    0xCA
#define Z_DOS_CP874_THAI_CHARACTER_HO_HIP	    0xCB
#define Z_DOS_CP874_THAI_CHARACTER_LO_CHULA	    0xCC
#define Z_DOS_CP874_THAI_CHARACTER_O_ANG	    0xCD
#define Z_DOS_CP874_THAI_CHARACTER_HO_NOKHUK	    0xCE
#define Z_DOS_CP874_THAI_CHARACTER_PAIYANNOI	    0xCF
#define Z_DOS_CP874_THAI_CHARACTER_SARA_A	    0xD0
#define Z_DOS_CP874_THAI_CHARACTER_MAI_HAN_AKAT	    0xD1
#define Z_DOS_CP874_THAI_CHARACTER_SARA_AA	    0xD2
#define Z_DOS_CP874_THAI_CHARACTER_SARA_AM	    0xD3
#define Z_DOS_CP874_THAI_CHARACTER_SARA_I	    0xD4
#define Z_DOS_CP874_THAI_CHARACTER_SARA_II	    0xD5
#define Z_DOS_CP874_THAI_CHARACTER_SARA_UE	    0xD6
#define Z_DOS_CP874_THAI_CHARACTER_SARA_UEE	    0xD7
#define Z_DOS_CP874_THAI_CHARACTER_SARA_U	    0xD8
#define Z_DOS_CP874_THAI_CHARACTER_SARA_UU	    0xD9
#define Z_DOS_CP874_THAI_CHARACTER_PHINTHU	    0xDA
/* DBh undefined */
/* DCh undefined */
/* DDh undefined */
/* DEh undefined */
#define Z_DOS_CP874_THAI_CURRENCY_SYMBOL_BAHT	    0xDF
#define Z_DOS_CP874_THAI_CHARACTER_SARA_E	    0xE0
#define Z_DOS_CP874_THAI_CHARACTER_SARA_AE	    0xE1
#define Z_DOS_CP874_THAI_CHARACTER_SARA_O	    0xE2
#define Z_DOS_CP874_THAI_CHARACTER_SARA_AI_MAIMUAN  0xE3
#define Z_DOS_CP874_THAI_CHARACTER_SARA_AI_MAIMALAI 0xE4
#define Z_DOS_CP874_THAI_CHARACTER_LAKKHANGYAO	    0xE5
#define Z_DOS_CP874_THAI_CHARACTER_MAIYAMOK	    0xE6
#define Z_DOS_CP874_THAI_CHARACTER_MAITAIKHU	    0xE7
#define Z_DOS_CP874_THAI_CHARACTER_MAI_EK	    0xE8
#define Z_DOS_CP874_THAI_CHARACTER_MAI_THO	    0xE9
#define Z_DOS_CP874_THAI_CHARACTER_MAI_TRI	    0xEA
#define Z_DOS_CP874_THAI_CHARACTER_MAI_CHATTAWA	    0xEB
#define Z_DOS_CP874_THAI_CHARACTER_THANTHAKHAT	    0xEC
#define Z_DOS_CP874_THAI_CHARACTER_NIKHAHIT	    0xED
#define Z_DOS_CP874_THAI_CHARACTER_YAMAKKAN	    0xEE
#define Z_DOS_CP874_THAI_CHARACTER_FONGMAN	    0xEF
#define Z_DOS_CP874_THAI_DIGIT_ZERO		    0xF0
#define Z_DOS_CP874_THAI_DIGIT_ONE		    0xF1
#define Z_DOS_CP874_THAI_DIGIT_TWO		    0xF2
#define Z_DOS_CP874_THAI_DIGIT_THREE		    0xF3
#define Z_DOS_CP874_THAI_DIGIT_FOUR		    0xF4
#define Z_DOS_CP874_THAI_DIGIT_FIVE		    0xF5
#define Z_DOS_CP874_THAI_DIGIT_SIX		    0xF6
#define Z_DOS_CP874_THAI_DIGIT_SEVEN		    0xF7
#define Z_DOS_CP874_THAI_DIGIT_EIGHT		    0xF8
#define Z_DOS_CP874_THAI_DIGIT_NINE		    0xF9
#define Z_DOS_CP874_THAI_CHARACTER_ANGKHANKHU	    0xFA
#define Z_DOS_CP874_THAI_CHARACTER_KHOMUT	    0xFB
/* FCh undefined */
/* FDh undefined */
/* FEh undefined */
/* FFh undefined */

#define Z_ARRAY_CONTENT_DOS_CP874_TO_UNICODE(_, undefined)					\
	_(20AC),   undefined, undefined, undefined, undefined, _(2026),	  undefined, undefined,	\
	undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined,	\
	undefined, _(2018),   _(2019),	 _(201C),   _(201D),   _(2022),	  _(2013),   _(2014),	\
	undefined, undefined, undefined, undefined, undefined, undefined, undefined, undefined,	\
	_(00A0),   _(0E01),   _(0E02),	 _(0E03),   _(0E04),   _(0E05),	  _(0E06),   _(0E07),	\
	_(0E08),   _(0E09),   _(0E0A),	 _(0E0B),   _(0E0C),   _(0E0D),	  _(0E0E),   _(0E0F),	\
	_(0E10),   _(0E11),   _(0E12),	 _(0E13),   _(0E14),   _(0E15),	  _(0E16),   _(0E17),	\
	_(0E18),   _(0E19),   _(0E1A),	 _(0E1B),   _(0E1C),   _(0E1D),	  _(0E1E),   _(0E1F),	\
	_(0E20),   _(0E21),   _(0E22),	 _(0E23),   _(0E24),   _(0E25),	  _(0E26),   _(0E27),	\
	_(0E28),   _(0E29),   _(0E2A),	 _(0E2B),   _(0E2C),   _(0E2D),	  _(0E2E),   _(0E2F),	\
	_(0E30),   _(0E31),   _(0E32),	 _(0E33),   _(0E34),   _(0E35),	  _(0E36),   _(0E37),	\
	_(0E38),   _(0E39),   _(0E3A),	 undefined, undefined, undefined, undefined, _(0E3F),	\
	_(0E40),   _(0E41),   _(0E42),	 _(0E43),   _(0E44),   _(0E45),	  _(0E46),   _(0E47),	\
	_(0E48),   _(0E49),   _(0E4A),	 _(0E4B),   _(0E4C),   _(0E4D),	  _(0E4E),   _(0E4F),	\
	_(0E50),   _(0E51),   _(0E52),	 _(0E53),   _(0E54),   _(0E55),	  _(0E56),   _(0E57),	\
	_(0E58),   _(0E59),   _(0E5A),	 _(0E5B),   undefined, undefined, undefined, undefined

#endif /* Z_formats_character_set_DOS_CP874_H */
