/* Zeta API - Z/formats/floating-point/x87.h
 ______ ____________  ___
|__   /|  ___|__  __|/   \
  /  /_|  __|  |  | /  *  \
 /_____|_____| |__|/__/ \__\
Copyright (C) 2006-2022 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef Z_formats_floating_point_x87_H
#define Z_formats_floating_point_x87_H

#define Z_X87_DOUBLE_EXTENDED_BITS		  80
#define Z_X87_DOUBLE_EXTENDED_BIAS		  16383
#define Z_X87_DOUBLE_EXTENDED_DIGITS_10		  19 /* 18 (?) */
#define Z_X87_DOUBLE_EXTENDED_MAXIMUM_DIGITS_10	  21
#define Z_X87_DOUBLE_EXTENDED_RADIX		  2
#define Z_X87_DOUBLE_EXTENDED_SIGNIFICAND_DIGITS  64
#define Z_X87_DOUBLE_EXTENDED_EXPONENT_MAXIMUM	  16383
#define Z_X87_DOUBLE_EXTENDED_EXPONENT_MINIMUM	  -16382
#define Z_X87_DOUBLE_EXTENDED_EXPONENT_10_MAXIMUM 4932
#define Z_X87_DOUBLE_EXTENDED_EXPONENT_10_MINIMUM -4931
#define Z_X87_DOUBLE_EXTENDED_EPSILON		  1.08420217248550443401e-19
#define Z_X87_DOUBLE_EXTENDED_MAXIMUM		  1.18973149535723176502e+4932
#define Z_X87_DOUBLE_EXTENDED_MINIMUM		  3.36210314311209350626e-4932
#define Z_X87_DOUBLE_EXTENDED_DENORMAL_MINIMUM	  3.64519953188247460253e-4951

#endif /* Z_formats_floating_point_x87_H */
