/* Zeta API - Z/formats/keymap/Mac OS.h
 ______ ____________  ___
|__   /|  ___|__  __|/   \
  /  /_|  __|  |  | /  *  \
 /_____|_____| |__|/__/ \__\
Copyright (C) 2006-2022 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef Z_formats_keymap_Mac_OS_H
#define Z_formats_keymap_Mac_OS_H

#define Z_MAC_OS_KEY_CODE_ANSI_A			  0
#define Z_MAC_OS_KEY_CODE_ANSI_S			  1
#define Z_MAC_OS_KEY_CODE_ANSI_D			  2
#define Z_MAC_OS_KEY_CODE_ANSI_F			  3
#define Z_MAC_OS_KEY_CODE_ANSI_H			  4
#define Z_MAC_OS_KEY_CODE_ANSI_G			  5
#define Z_MAC_OS_KEY_CODE_ANSI_Z			  6
#define Z_MAC_OS_KEY_CODE_ANSI_X			  7
#define Z_MAC_OS_KEY_CODE_ANSI_C			  8
#define Z_MAC_OS_KEY_CODE_ANSI_V			  9
#define Z_MAC_OS_KEY_CODE_ISO_SECTION			 10
#define Z_MAC_OS_KEY_CODE_ANSI_B			 11
#define Z_MAC_OS_KEY_CODE_ANSI_Q			 12
#define Z_MAC_OS_KEY_CODE_ANSI_W			 13
#define Z_MAC_OS_KEY_CODE_ANSI_E			 14
#define Z_MAC_OS_KEY_CODE_ANSI_R			 15
#define Z_MAC_OS_KEY_CODE_ANSI_Y			 16
#define Z_MAC_OS_KEY_CODE_ANSI_T			 17
#define Z_MAC_OS_KEY_CODE_ANSI_1			 18
#define Z_MAC_OS_KEY_CODE_ANSI_2			 19
#define Z_MAC_OS_KEY_CODE_ANSI_3			 20
#define Z_MAC_OS_KEY_CODE_ANSI_4			 21
#define Z_MAC_OS_KEY_CODE_ANSI_6			 22
#define Z_MAC_OS_KEY_CODE_ANSI_5			 23
#define Z_MAC_OS_KEY_CODE_ANSI_EQUALS_SIGN		 24
#define Z_MAC_OS_KEY_CODE_ANSI_9			 25
#define Z_MAC_OS_KEY_CODE_ANSI_7			 26
#define Z_MAC_OS_KEY_CODE_ANSI_HYPHEN_MINUS		 27
#define Z_MAC_OS_KEY_CODE_ANSI_8			 28
#define Z_MAC_OS_KEY_CODE_ANSI_0			 29
#define Z_MAC_OS_KEY_CODE_ANSI_RIGHT_SQUARE_BRACKET	 30
#define Z_MAC_OS_KEY_CODE_ANSI_O			 31
#define Z_MAC_OS_KEY_CODE_ANSI_U			 32
#define Z_MAC_OS_KEY_CODE_ANSI_LEFT_SQUARE_BRACKET	 33
#define Z_MAC_OS_KEY_CODE_ANSI_I			 34
#define Z_MAC_OS_KEY_CODE_ANSI_P			 35
#define Z_MAC_OS_KEY_CODE_RETURN			 36
#define Z_MAC_OS_KEY_CODE_ANSI_L			 37
#define Z_MAC_OS_KEY_CODE_ANSI_J			 38
#define Z_MAC_OS_KEY_CODE_ANSI_APOSTROPHE		 39
#define Z_MAC_OS_KEY_CODE_ANSI_K			 40
#define Z_MAC_OS_KEY_CODE_ANSI_SEMICOLON		 41
#define Z_MAC_OS_KEY_CODE_ANSI_REVERSE_SOLIDUS		 42
#define Z_MAC_OS_KEY_CODE_ANSI_COMMA			 43
#define Z_MAC_OS_KEY_CODE_ANSI_SOLIDUS			 44
#define Z_MAC_OS_KEY_CODE_ANSI_N			 45
#define Z_MAC_OS_KEY_CODE_ANSI_M			 46
#define Z_MAC_OS_KEY_CODE_ANSI_FULL_STOP		 47
#define Z_MAC_OS_KEY_CODE_TAB				 48
#define Z_MAC_OS_KEY_CODE_SPACE				 49
#define Z_MAC_OS_KEY_CODE_ANSI_GRAVE_ACCENT		 50
#define Z_MAC_OS_KEY_CODE_BACKSPACE			 51
/* 52 - Unused? */
#define Z_MAC_OS_KEY_CODE_ESCAPE			 53
#define Z_MAC_OS_KEY_CODE_RIGHT_COMMAND			 54
#define Z_MAC_OS_KEY_CODE_LEFT_COMMAND			 55
#define Z_MAC_OS_KEY_CODE_LEFT_SHIFT			 56
#define Z_MAC_OS_KEY_CODE_CAPS_LOCK			 57
#define Z_MAC_OS_KEY_CODE_LEFT_OPTION			 58
#define Z_MAC_OS_KEY_CODE_LEFT_CONTROL			 59
#define Z_MAC_OS_KEY_CODE_RIGHT_SHIFT			 60
#define Z_MAC_OS_KEY_CODE_RIGHT_OPTION			 61
#define Z_MAC_OS_KEY_CODE_RIGHT_CONTROL			 62
#define Z_MAC_OS_KEY_CODE_FUNCTION			 63
#define Z_MAC_OS_KEY_CODE_F17				 64
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_DECIMAL_SEPARATOR	 65
/* 66 - Unused? */
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_ASTERISK		 67
/* 68 - Unused? */
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_PLUS_SIGN		 69
/* 70 - Unused? */
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_CLEAR		 71
#define Z_MAC_OS_KEY_CODE_VOLUME_UP			 72
#define Z_MAC_OS_KEY_CODE_VOLUME_DOWN			 73
#define Z_MAC_OS_KEY_CODE_MUTE				 74
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_SOLIDUS		 75 /* PC keyboards */
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_ENTER		 76
/* 77 - Unused? */
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_HYPHEN_MINUS	 78
#define Z_MAC_OS_KEY_CODE_F18				 79
#define Z_MAC_OS_KEY_CODE_F19				 80
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_EQUALS_SIGN	 81
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_0			 82
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_1			 83
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_2			 84
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_3			 85
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_4			 86
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_5			 87
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_6			 88
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_7			 89
#define Z_MAC_OS_KEY_CODE_F20				 90
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_8			 91
#define Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_9			 92
#define Z_MAC_OS_KEY_CODE_JIS_YEN_SIGN			 93
#define Z_MAC_OS_KEY_CODE_JIS_LOW_LINE			 94
#define Z_MAC_OS_KEY_CODE_JIS_KEYPAD_COMMA		 95
#define Z_MAC_OS_KEY_CODE_F5				 96
#define Z_MAC_OS_KEY_CODE_F6				 97
#define Z_MAC_OS_KEY_CODE_F7				 98
#define Z_MAC_OS_KEY_CODE_F3				 99
#define Z_MAC_OS_KEY_CODE_F8				100
#define Z_MAC_OS_KEY_CODE_F9				101
#define Z_MAC_OS_KEY_CODE_JIS_EISU			102 /* Toggles alphanumeric characters */
#define Z_MAC_OS_KEY_CODE_F11				103
#define Z_MAC_OS_KEY_CODE_JIS_KANA			104
#define Z_MAC_OS_KEY_CODE_F13				105
#define Z_MAC_OS_KEY_CODE_F16				106
#define Z_MAC_OS_KEY_CODE_F14				107
/* 108 - Unused? */
#define Z_MAC_OS_KEY_CODE_F10				109
#define Z_MAC_OS_KEY_CODE_APPLICATION			110 /* PC/Windows keyboards */
#define Z_MAC_OS_KEY_CODE_F12				111
/* 112 - Unused? */
#define Z_MAC_OS_KEY_CODE_F15				113
#define Z_MAC_OS_KEY_CODE_HELP				114
#define Z_MAC_OS_KEY_CODE_HOME				115
#define Z_MAC_OS_KEY_CODE_PAGE_UP			116
#define Z_MAC_OS_KEY_CODE_DELETE			117
#define Z_MAC_OS_KEY_CODE_F4				118
#define Z_MAC_OS_KEY_CODE_END				119
#define Z_MAC_OS_KEY_CODE_F2				120
#define Z_MAC_OS_KEY_CODE_PAGE_DOWN			121
#define Z_MAC_OS_KEY_CODE_F1				122
#define Z_MAC_OS_KEY_CODE_LEFT				123
#define Z_MAC_OS_KEY_CODE_RIGHT				124
#define Z_MAC_OS_KEY_CODE_DOWN				125
#define Z_MAC_OS_KEY_CODE_UP				126
/* 127 - Unused? */

#define Z_MAC_OS_KEY_MASK_CAPS_LOCK	0x010000
#define Z_MAC_OS_KEY_MASK_SHIFT		0x020000
#define Z_MAC_OS_KEY_MASK_CONTROL	0x040000
#define Z_MAC_OS_KEY_MASK_COMMAND	0x100000
#define Z_MAC_OS_KEY_MASK_OPTION        0x080000
#define Z_MAC_OS_KEY_MASK_LEFT_SHIFT	0x000002
#define Z_MAC_OS_KEY_MASK_LEFT_CONTROL	0x000001
#define Z_MAC_OS_KEY_MASK_LEFT_COMMAND	0x000008
#define Z_MAC_OS_KEY_MASK_LEFT_OPTION	0x000020
#define Z_MAC_OS_KEY_MASK_RIGHT_OPTION	0x000040
#define Z_MAC_OS_KEY_MASK_RIGHT_COMMAND	0x000010
#define Z_MAC_OS_KEY_MASK_RIGHT_CONTROL	0x002000
#define Z_MAC_OS_KEY_MASK_RIGHT_SHIFT	0x000004

#define Z_ARRAY_CONTENT_MAC_OS_KEY_CODE_TO_Z_KEY_CODE							      \
	Z_KEY_CODE_ANSI_A,			  /*   0 - Z_MAC_OS_KEY_CODE_ANSI_A			   */ \
	Z_KEY_CODE_ANSI_S,			  /*   1 - Z_MAC_OS_KEY_CODE_ANSI_S			   */ \
	Z_KEY_CODE_ANSI_D,			  /*   2 - Z_MAC_OS_KEY_CODE_ANSI_D			   */ \
	Z_KEY_CODE_ANSI_F,			  /*   3 - Z_MAC_OS_KEY_CODE_ANSI_F			   */ \
	Z_KEY_CODE_ANSI_H,			  /*   4 - Z_MAC_OS_KEY_CODE_ANSI_H			   */ \
	Z_KEY_CODE_ANSI_G,			  /*   5 - Z_MAC_OS_KEY_CODE_ANSI_G			   */ \
	Z_KEY_CODE_ANSI_Z,			  /*   6 - Z_MAC_OS_KEY_CODE_ANSI_Z			   */ \
	Z_KEY_CODE_ANSI_X,			  /*   7 - Z_MAC_OS_KEY_CODE_ANSI_X			   */ \
	Z_KEY_CODE_ANSI_C,			  /*   8 - Z_MAC_OS_KEY_CODE_ANSI_C			   */ \
	Z_KEY_CODE_ANSI_V,			  /*   9 - Z_MAC_OS_KEY_CODE_ANSI_V			   */ \
	Z_KEY_CODE_ISO_SECTION,			  /*  10 - Z_MAC_OS_KEY_CODE_ISO_SECTION		   */ \
	Z_KEY_CODE_ANSI_B,			  /*  11 - Z_MAC_OS_KEY_CODE_ANSI_B			   */ \
	Z_KEY_CODE_ANSI_Q,			  /*  12 - Z_MAC_OS_KEY_CODE_ANSI_Q			   */ \
	Z_KEY_CODE_ANSI_W,			  /*  13 - Z_MAC_OS_KEY_CODE_ANSI_W			   */ \
	Z_KEY_CODE_ANSI_E,			  /*  14 - Z_MAC_OS_KEY_CODE_ANSI_E			   */ \
	Z_KEY_CODE_ANSI_R,			  /*  15 - Z_MAC_OS_KEY_CODE_ANSI_R			   */ \
	Z_KEY_CODE_ANSI_Y,			  /*  16 - Z_MAC_OS_KEY_CODE_ANSI_Y			   */ \
	Z_KEY_CODE_ANSI_T,			  /*  17 - Z_MAC_OS_KEY_CODE_ANSI_T			   */ \
	Z_KEY_CODE_ANSI_1,			  /*  18 - Z_MAC_OS_KEY_CODE_ANSI_1			   */ \
	Z_KEY_CODE_ANSI_2,			  /*  19 - Z_MAC_OS_KEY_CODE_ANSI_2			   */ \
	Z_KEY_CODE_ANSI_3,			  /*  20 - Z_MAC_OS_KEY_CODE_ANSI_3			   */ \
	Z_KEY_CODE_ANSI_4,			  /*  21 - Z_MAC_OS_KEY_CODE_ANSI_4			   */ \
	Z_KEY_CODE_ANSI_6,			  /*  22 - Z_MAC_OS_KEY_CODE_ANSI_6			   */ \
	Z_KEY_CODE_ANSI_5,			  /*  23 - Z_MAC_OS_KEY_CODE_ANSI_5			   */ \
	Z_KEY_CODE_ANSI_EQUALS_SIGN,		  /*  24 - Z_MAC_OS_KEY_CODE_ANSI_EQUALS_SIGN		   */ \
	Z_KEY_CODE_ANSI_9,			  /*  25 - Z_MAC_OS_KEY_CODE_ANSI_9			   */ \
	Z_KEY_CODE_ANSI_7,			  /*  26 - Z_MAC_OS_KEY_CODE_ANSI_7			   */ \
	Z_KEY_CODE_ANSI_HYPHEN_MINUS,		  /*  27 - Z_MAC_OS_KEY_CODE_ANSI_HYPHEN_MINUS		   */ \
	Z_KEY_CODE_ANSI_8,			  /*  28 - Z_MAC_OS_KEY_CODE_ANSI_8			   */ \
	Z_KEY_CODE_ANSI_0,			  /*  29 - Z_MAC_OS_KEY_CODE_ANSI_0			   */ \
	Z_KEY_CODE_ANSI_RIGHT_SQUARE_BRACKET,	  /*  30 - Z_MAC_OS_KEY_CODE_ANSI_RIGHT_SQUARE_BRACKET	   */ \
	Z_KEY_CODE_ANSI_O,			  /*  31 - Z_MAC_OS_KEY_CODE_ANSI_O			   */ \
	Z_KEY_CODE_ANSI_U,			  /*  32 - Z_MAC_OS_KEY_CODE_ANSI_U			   */ \
	Z_KEY_CODE_ANSI_LEFT_SQUARE_BRACKET,	  /*  33 - Z_MAC_OS_KEY_CODE_ANSI_LEFT_SQUARE_BRACKET	   */ \
	Z_KEY_CODE_ANSI_I,			  /*  34 - Z_MAC_OS_KEY_CODE_ANSI_I			   */ \
	Z_KEY_CODE_ANSI_P,			  /*  35 - Z_MAC_OS_KEY_CODE_ANSI_P			   */ \
	Z_KEY_CODE_RETURN,			  /*  36 - Z_MAC_OS_KEY_CODE_RETURN			   */ \
	Z_KEY_CODE_ANSI_L,			  /*  37 - Z_MAC_OS_KEY_CODE_ANSI_L			   */ \
	Z_KEY_CODE_ANSI_J,			  /*  38 - Z_MAC_OS_KEY_CODE_ANSI_J			   */ \
	Z_KEY_CODE_ANSI_APOSTROPHE,		  /*  39 - Z_MAC_OS_KEY_CODE_ANSI_APOSTROPHE		   */ \
	Z_KEY_CODE_ANSI_K,			  /*  40 - Z_MAC_OS_KEY_CODE_ANSI_K			   */ \
	Z_KEY_CODE_ANSI_SEMICOLON,		  /*  41 - Z_MAC_OS_KEY_CODE_ANSI_SEMICOLON		   */ \
	Z_KEY_CODE_ANSI_REVERSE_SOLIDUS,	  /*  42 - Z_MAC_OS_KEY_CODE_ANSI_REVERSE_SOLIDUS	   */ \
	Z_KEY_CODE_ANSI_COMMA,			  /*  43 - Z_MAC_OS_KEY_CODE_ANSI_COMMA			   */ \
	Z_KEY_CODE_ANSI_SOLIDUS,		  /*  44 - Z_MAC_OS_KEY_CODE_ANSI_SOLIDUS		   */ \
	Z_KEY_CODE_ANSI_N,			  /*  45 - Z_MAC_OS_KEY_CODE_ANSI_N			   */ \
	Z_KEY_CODE_ANSI_M,			  /*  46 - Z_MAC_OS_KEY_CODE_ANSI_M			   */ \
	Z_KEY_CODE_ANSI_FULL_STOP,		  /*  47 - Z_MAC_OS_KEY_CODE_ANSI_FULL_STOP		   */ \
	Z_KEY_CODE_TAB,				  /*  48 - Z_MAC_OS_KEY_CODE_TAB			   */ \
	Z_KEY_CODE_SPACE,			  /*  49 - Z_MAC_OS_KEY_CODE_SPACE			   */ \
	Z_KEY_CODE_ANSI_GRAVE_ACCENT,		  /*  50 - Z_MAC_OS_KEY_CODE_ANSI_GRAVE_ACCENT		   */ \
	Z_KEY_CODE_BACKSPACE,			  /*  51 - Z_MAC_OS_KEY_CODE_BACKSPACE			   */ \
	Z_KEY_CODE_INVALID,			  /*  52						   */ \
	Z_KEY_CODE_ESCAPE,			  /*  53 - Z_MAC_OS_KEY_CODE_ESCAPE			   */ \
	Z_KEY_CODE_RIGHT_COMMAND,		  /*  54 - Z_MAC_OS_KEY_CODE_RIGHT_COMMAND		   */ \
	Z_KEY_CODE_LEFT_COMMAND,		  /*  55 - Z_MAC_OS_KEY_CODE_LEFT_COMMAND		   */ \
	Z_KEY_CODE_LEFT_SHIFT,			  /*  56 - Z_MAC_OS_KEY_CODE_LEFT_SHIFT			   */ \
	Z_KEY_CODE_CAPS_LOCK,			  /*  57 - Z_MAC_OS_KEY_CODE_CAPS_LOCK			   */ \
	Z_KEY_CODE_LEFT_OPTION,			  /*  58 - Z_MAC_OS_KEY_CODE_LEFT_OPTION		   */ \
	Z_KEY_CODE_LEFT_CONTROL,		  /*  59 - Z_MAC_OS_KEY_CODE_LEFT_CONTROL		   */ \
	Z_KEY_CODE_RIGHT_SHIFT,			  /*  60 - Z_MAC_OS_KEY_CODE_RIGHT_SHIFT		   */ \
	Z_KEY_CODE_RIGHT_OPTION,		  /*  61 - Z_MAC_OS_KEY_CODE_RIGHT_OPTION		   */ \
	Z_KEY_CODE_RIGHT_CONTROL,		  /*  62 - Z_MAC_OS_KEY_CODE_RIGHT_CONTROL		   */ \
	Z_KEY_CODE_FUNCTION,			  /*  63 - Z_MAC_OS_KEY_CODE_FUNCTION			   */ \
	Z_KEY_CODE_F17,				  /*  64 - Z_MAC_OS_KEY_CODE_F17			   */ \
	Z_KEY_CODE_ANSI_KEYPAD_DECIMAL_SEPARATOR, /*  65 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_DECIMAL_SEPARATOR */ \
	Z_KEY_CODE_INVALID,			  /*  66						   */ \
	Z_KEY_CODE_ANSI_KEYPAD_ASTERISK,	  /*  67 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_ASTERISK	   */ \
	Z_KEY_CODE_INVALID,			  /*  68						   */ \
	Z_KEY_CODE_ANSI_KEYPAD_PLUS_SIGN,	  /*  69 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_PLUS_SIGN	   */ \
	Z_KEY_CODE_INVALID,			  /*  70						   */ \
	Z_KEY_CODE_ANSI_KEYPAD_NUM_LOCK,	  /*  71 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_CLEAR		   */ \
	Z_KEY_CODE_VOLUME_UP,			  /*  72 - Z_MAC_OS_KEY_CODE_VOLUME_UP			   */ \
	Z_KEY_CODE_VOLUME_DOWN,			  /*  73 - Z_MAC_OS_KEY_CODE_VOLUME_DOWN		   */ \
	Z_KEY_CODE_MUTE,			  /*  74 - Z_MAC_OS_KEY_CODE_MUTE			   */ \
	Z_KEY_CODE_ANSI_KEYPAD_SOLIDUS,		  /*  75 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_SOLIDUS	   */ \
	Z_KEY_CODE_ANSI_KEYPAD_ENTER,		  /*  76 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_ENTER		   */ \
	Z_KEY_CODE_INVALID,			  /*  77						   */ \
	Z_KEY_CODE_ANSI_KEYPAD_HYPHEN_MINUS,	  /*  78 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_HYPHEN_MINUS      */ \
	Z_KEY_CODE_F18,				  /*  79 - Z_MAC_OS_KEY_CODE_F18			   */ \
	Z_KEY_CODE_F19,				  /*  80 - Z_MAC_OS_KEY_CODE_F19			   */ \
	Z_KEY_CODE_APPLE_ANSI_KEYPAD_EQUALS_SIGN, /*  81 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_EQUALS_SIGN       */ \
	Z_KEY_CODE_ANSI_KEYPAD_0,		  /*  82 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_0		   */ \
	Z_KEY_CODE_ANSI_KEYPAD_1,		  /*  83 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_1		   */ \
	Z_KEY_CODE_ANSI_KEYPAD_2,		  /*  84 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_2		   */ \
	Z_KEY_CODE_ANSI_KEYPAD_3,		  /*  85 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_3		   */ \
	Z_KEY_CODE_ANSI_KEYPAD_4,		  /*  86 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_4		   */ \
	Z_KEY_CODE_ANSI_KEYPAD_5,		  /*  87 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_5		   */ \
	Z_KEY_CODE_ANSI_KEYPAD_6,		  /*  88 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_6		   */ \
	Z_KEY_CODE_ANSI_KEYPAD_7,		  /*  89 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_7		   */ \
	Z_KEY_CODE_F20,				  /*  90 - Z_MAC_OS_KEY_CODE_F20			   */ \
	Z_KEY_CODE_ANSI_KEYPAD_8,		  /*  91 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_8		   */ \
	Z_KEY_CODE_ANSI_KEYPAD_9,		  /*  92 - Z_MAC_OS_KEY_CODE_ANSI_KEYPAD_9		   */ \
	Z_KEY_CODE_JIS_YEN_SIGN,		  /*  93 - Z_MAC_OS_KEY_CODE_JIS_YEN_SIGN		   */ \
	Z_KEY_CODE_JIS_LOW_LINE,		  /*  94 - Z_MAC_OS_KEY_CODE_JIS_LOW_LINE		   */ \
	Z_KEY_CODE_JIS_KEYPAD_COMMA,		  /*  95 - Z_MAC_OS_KEY_CODE_JIS_KEYPAD_COMMA		   */ \
	Z_KEY_CODE_F5,				  /*  96 - Z_MAC_OS_KEY_CODE_F5				   */ \
	Z_KEY_CODE_F6,				  /*  97 - Z_MAC_OS_KEY_CODE_F6				   */ \
	Z_KEY_CODE_F7,				  /*  98 - Z_MAC_OS_KEY_CODE_F7				   */ \
	Z_KEY_CODE_F3,				  /*  99 - Z_MAC_OS_KEY_CODE_F3				   */ \
	Z_KEY_CODE_F8,				  /* 100 - Z_MAC_OS_KEY_CODE_F8				   */ \
	Z_KEY_CODE_F9,				  /* 101 - Z_MAC_OS_KEY_CODE_F9				   */ \
	Z_KEY_CODE_JIS_EISU,			  /* 102 - Z_MAC_OS_KEY_CODE_JIS_EISU			   */ \
	Z_KEY_CODE_F11,				  /* 103 - Z_MAC_OS_KEY_CODE_F11			   */ \
	Z_KEY_CODE_JIS_KANA,			  /* 104 - Z_MAC_OS_KEY_CODE_JIS_KANA			   */ \
	Z_KEY_CODE_PRINT_SCREEN,		  /* 105 - Z_MAC_OS_KEY_CODE_F13			   */ \
	Z_KEY_CODE_F16,				  /* 106 - Z_MAC_OS_KEY_CODE_F16			   */ \
	Z_KEY_CODE_SCROLL_LOCK,			  /* 107 - Z_MAC_OS_KEY_CODE_F14			   */ \
	Z_KEY_CODE_INVALID,			  /* 108						   */ \
	Z_KEY_CODE_F10,				  /* 109 - Z_MAC_OS_KEY_CODE_F10			   */ \
	Z_KEY_CODE_APPLICATION,			  /* 110 - Z_MAC_OS_KEY_CODE_APPLICATION		   */ \
	Z_KEY_CODE_F12,				  /* 111 - Z_MAC_OS_KEY_CODE_F12			   */ \
	Z_KEY_CODE_INVALID,			  /* 112						   */ \
	Z_KEY_CODE_PAUSE,			  /* 113 - Z_MAC_OS_KEY_CODE_F15			   */ \
	Z_KEY_CODE_INSERT,			  /* 114 - Z_MAC_OS_KEY_CODE_HELP			   */ \
	Z_KEY_CODE_HOME,			  /* 115 - Z_MAC_OS_KEY_CODE_HOME			   */ \
	Z_KEY_CODE_PAGE_UP,			  /* 116 - Z_MAC_OS_KEY_CODE_PAGE_UP			   */ \
	Z_KEY_CODE_DELETE,			  /* 117 - Z_MAC_OS_KEY_CODE_DELETE			   */ \
	Z_KEY_CODE_F4,				  /* 118 - Z_MAC_OS_KEY_CODE_F4				   */ \
	Z_KEY_CODE_END,				  /* 119 - Z_MAC_OS_KEY_CODE_END			   */ \
	Z_KEY_CODE_F2,				  /* 120 - Z_MAC_OS_KEY_CODE_F2				   */ \
	Z_KEY_CODE_PAGE_DOWN,			  /* 121 - Z_MAC_OS_KEY_CODE_PAGE_DOWN			   */ \
	Z_KEY_CODE_F1,				  /* 122 - Z_MAC_OS_KEY_CODE_F1				   */ \
	Z_KEY_CODE_LEFT,			  /* 123 - Z_MAC_OS_KEY_CODE_LEFT			   */ \
	Z_KEY_CODE_RIGHT,			  /* 124 - Z_MAC_OS_KEY_CODE_RIGHT			   */ \
	Z_KEY_CODE_DOWN,			  /* 125 - Z_MAC_OS_KEY_CODE_DOWN			   */ \
	Z_KEY_CODE_UP,				  /* 126 - Z_MAC_OS_KEY_CODE_UP				   */ \
	Z_KEY_CODE_INVALID			  /* 127						   */

#endif /* Z_formats_keymap_Mac_OS_H */
