/* Zeta API - Z/inspection/compiler/modules/Clang.h
 ______ ____________  ___
|__   /|  ___|__  __|/   \
  /  /_|  __|  |  | /  *  \
 /_____|_____| |__|/__/ \__\
Copyright (C) 2006-2022 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef Z_inspection_compiler_modules_MSVC_H

/* MARK: - Identification */

#define Z_COMPILER_IS_MSVC TRUE
#define Z_COMPILER_NAME	   Z_COMPILER_NAME_MSVC

#if _MSC_VER == 800
#	define Z_COMPILER_VERSION Z_VERSION(1,0,0)

#elif _MSC_VER == 900
#	define Z_COMPILER_VERSION Z_VERSION(2,0,0)

#elif _MSC_VER == 1000 /* Developer Studio v4.0 */
#	define Z_COMPILER_VERSION Z_VERSION(4,0,0)

#elif _MSC_VER == 1020 /* Developer Studio v4.2 */
#	define Z_COMPILER_VERSION Z_VERSION(4,2,0)

#elif _MSC_VER == 1100 /* Visual Studio 97 v5.0 */
#	define Z_COMPILER_VERSION Z_VERSION(5,0,0)

#elif _MSC_VER == 1200 /* Visual Studio 6.0 v6.0 */
#	define Z_COMPILER_VERSION Z_VERSION(6,0,0)

#elif _MSC_VER == 1300 /* Visual Studio .NET 2002 v7.0 */
#	define Z_COMPILER_VERSION Z_VERSION(7,0,0)

#elif _MSC_VER == 1310 /* Visual Studio .NET 2003 v7.1 */
#	define Z_COMPILER_VERSION Z_VERSION(7,1,0)

#elif _MSC_VER == 1400 /* Visual Studio 2005 v8.0 */
#	define Z_COMPILER_VERSION Z_VERSION(8,0,0)

#elif _MSC_VER == 1500 /* Visual Studio 2008 v9.0 */
#	define Z_COMPILER_VERSION Z_VERSION(9,0,0)

#elif _MSC_VER == 1600 /* Visual Studio 2010 v10.0 */
#	define Z_COMPILER_VERSION Z_VERSION(10,0,0)

#elif _MSC_VER == 1700 /* Visual Studio 2012 v11.0 */
#	define Z_COMPILER_VERSION Z_VERSION(11,0,0)

#elif _MSC_VER == 1800 /* Visual Studio 2013 v12.0 */
#	define Z_COMPILER_VERSION Z_VERSION(12,0,0)

#elif _MSC_VER == 1900 /* Visual Studio 2015 v14.0 */
#	define Z_COMPILER_VERSION Z_VERSION(14,0,0)

#elif _MSC_VER == 1910 /* Visual Studio 2017 v15.0 */
#	define Z_COMPILER_VERSION Z_VERSION(14,1,0)

#elif _MSC_VER == 1911 /* Visual Studio 2017 v15.3 */
#	define Z_COMPILER_VERSION Z_VERSION(14,11,0)

#elif _MSC_VER == 1912 /* Visual Studio 2017 v15.5 */
#	define Z_COMPILER_VERSION Z_VERSION(14,12,0)

#elif _MSC_VER == 1913 /* Visual Studio 2017 v15.6 */
#	define Z_COMPILER_VERSION Z_VERSION(14,13,0)

#elif _MSC_VER == 1914 /* Visual Studio 2017 v15.7 */
#	define Z_COMPILER_VERSION Z_VERSION(14,14,0)

#elif _MSC_VER == 1915 /* Visual Studio 2017 v15.8 */
#	define Z_COMPILER_VERSION Z_VERSION(14,15,0)

#elif _MSC_VER == 1916 /* Visual Studio 2017 v15.9 */
#	define Z_COMPILER_VERSION Z_VERSION(14,16,0)

#elif _MSC_VER == 1920 /* Visual Studio 2019 v16.0 */
#	define Z_COMPILER_VERSION Z_VERSION(14,2,0)

#elif _MSC_VER == 1921 /* Visual Studio 2019 v16.1 */
#	define Z_COMPILER_VERSION Z_VERSION(14,21,0)

#elif _MSC_VER == 1922 /* Visual Studio 2019 v16.2 */
#	define Z_COMPILER_VERSION Z_VERSION(14,22,0)

#elif _MSC_VER == 1923 /* Visual Studio 2019 v16.3 */
#	define Z_COMPILER_VERSION Z_VERSION(14,23,0)
#endif

/* MARK: - ISA */

#if defined(_M_AMD64) || defined(_M_X64)
#	define Z_COMPILER_ISA Z_ISA_X86_64

#elif defined(_M_IX86)
#	define Z_COMPILER_ISA Z_ISA_X86_32

#elif defined(_M_ARM64)
#	define Z_COMPILER_ISA Z_ISA_AARCH64

#elif defined(_M_ARM)
#	define Z_COMPILER_ISA Z_ISA_AARCH32

#elif defined(_M_ALPHA)
#	define Z_COMPILER_ISA Z_ISA_ALPHA

#elif defined(_M_IA64)
#	define Z_COMPILER_ISA Z_ISA_ITANIUM

#elif defined(_M_MRX000)
#	define Z_COMPILER_ISA Z_ISA_MIPS

#elif defined(_M_MPPC) defined(_M_PPC)
#	define Z_COMPILER_ISA Z_ISA_POWERPC_32BIT
#endif

/*#define Z_COMPILER_ISA_INTEGRAL_ENDIANNESS*/

/* MARK: - Platform */

#if defined(_M_MPPC)
#	define Z_COMPILER_PLATFORM Z_PLATFORM_MACINTOSH
#endif

/* MARK: - OS */

/*#define Z_COMPIER_OS*/

/* MARK: - Bit field order */

/*#define Z_COMPILER_BIT_FIELD_ORDER_ALL*/
/*#define Z_COMPILER_BIT_FIELD_ORDER_8BIT*/
/*#define Z_COMPILER_BIT_FIELD_ORDER_16BIT*/
/*#define Z_COMPILER_BIT_FIELD_ORDER_32BIT*/
/*#define Z_COMPILER_BIT_FIELD_ORDER_64BIT*/
/*#define Z_COMPILER_BIT_FIELD_ORDER_128BIT*/

/* MARK: - Data model */

/*#define Z_COMPILER_DATA_MODEL*/

/* MARK: - Floating-point */

/*#define Z_COMPILER_FIXED_FUNDAMENTAL_FLOAT*/
/*#define Z_COMPILER_FIXED_FUNDAMENTAL_DOUBLE*/
/*#define Z_COMPILER_FIXED_FUNDAMENTAL_LDOUBLE*/
/*#define Z_COMPILER_FIXED_FUNDAMENTAL_FLOAT32X*/
/*#define Z_COMPILER_FIXED_FUNDAMENTAL_FLOAT64X*/
/*#define Z_COMPILER_FIXED_FUNDAMENTAL_FLOAT128X*/
/*#define Z_COMPILER_FIXED_FUNDAMENTAL_DECIMAL64X*/
/*#define Z_COMPILER_FIXED_FUNDAMENTAL_DECIMAL128X*/

/* MARK: - Language: C78 */

/*#define Z_COMPILER_HAS_C_OLD_STYLE_FUNCTION*/
#define Z_COMPILER_HAS_C_OPERATOR_SIZEOF TRUE
/*#define Z_COMPILER_HAS_C_STORAGE_CLASS_AUTO*/
#define Z_COMPILER_HAS_C_STORAGE_CLASS_EXTERN TRUE
/*#define Z_COMPILER_HAS_C_STORAGE_CLASS_REGISTER*/
#define Z_COMPILER_HAS_C_STORAGE_CLASS_STATIC TRUE
/*#define Z_COMPILER_HAS_C_TYPE_DOUBLE*/
/*#define Z_COMPILER_HAS_C_TYPE_FLOAT*/

/* MARK: - Language: C89 */

/*#define Z_COMPILER_HAS_C89_CONSTANT_INITIALIZATION_FOR_LOCAL_AGGREGATE*/
/*#define Z_COMPILER_HAS_C89_CONSTANT_INITIALIZATION_FOR_UNION*/
/*#define Z_COMPILER_HAS_C89_CONSTRUCT_AS_FUNCTION_ARGUMENT*/
/*#define Z_COMPILER_HAS_C89_CONSTRUCT_RETURN*/
/*#define Z_COMPILER_HAS_C89_CONSTRUCT_ASSIGNMENT*/
/*#define Z_COMPILER_HAS_C89_CONSTRUCT_NAMESPACE*/
#define Z_COMPILER_HAS_C89_ENUMERATION TRUE
/*#define Z_COMPILER_HAS_C89_FUNCTION_POINTER_AUTODEREFERENCING*/
/*#define Z_COMPILER_HAS_C89_FUNCTION_PROTOTYPE*/
#define Z_COMPILER_HAS_C89_INTEGRAL_SWITCH TRUE
#define Z_COMPILER_HAS_C89_PREPROCESSOR_INDENTATION TRUE
/*#define Z_COMPILER_HAS_C89_REMOVAL_OF_ENTRY_AS_KEYWORD*/
/*#define Z_COMPILER_HAS_C89_REMOVAL_OF_LONG_FLOAT_AS_TYPE*/
/*#define Z_COMPILER_HAS_C89_STRING_LITERAL_CONCATENATION*/
/*#define Z_COMPILER_HAS_C89_TRIGRAPHS*/
/*#define Z_COMPILER_HAS_C89_VALUE_PRESERVING_UNSIGNED_CONVERSION*/
/*#define Z_COMPILER_HAS_C89_ESCAPE_SEQUENCE_ALERT*/
/*#define Z_COMPILER_HAS_C89_ESCAPE_SEQUENCE_HEXADECIMAL*/
/*#define Z_COMPILER_HAS_C89_ESCAPE_SEQUENCE_VERTICAL_TAB*/
/*#define Z_COMPILER_HAS_C89_LITERAL_FLOAT*/
#define Z_COMPILER_HAS_C89_LITERAL_UNSIGNED TRUE
/*#define Z_COMPILER_HAS_C89_LITERAL_WCHAR_T_CHARACTER*/
/*#define Z_COMPILER_HAS_C89_LITERAL_WCHAR_T_STRING*/
/*#define Z_COMPILER_HAS_C89_OPERATOR_UNARY_PLUS*/
#define Z_COMPILER_HAS_C89_PREPROCESSOR_DIRECTIVE_NULL TRUE
#define Z_COMPILER_HAS_C89_PREPROCESSOR_DIRECTIVE_ELIF TRUE
#define Z_COMPILER_HAS_C89_PREPROCESSOR_DIRECTIVE_ERROR TRUE
#define Z_COMPILER_HAS_C89_PREPROCESSOR_DIRECTIVE_LINE TRUE
#define Z_COMPILER_HAS_C89_PREPROCESSOR_DIRECTIVE_PRAGMA TRUE
#define Z_COMPILER_HAS_C89_PREPROCESSOR_OPERATOR_DEFINED TRUE
/*#define Z_COMPILER_HAS_C89_PREPROCESSOR_OPERATOR_PASTING*/
/*#define Z_COMPILER_HAS_C89_PREPROCESSOR_OPERATOR_STRINGIZING*/
/*#define Z_COMPILER_HAS_C89_TYPE_LONG_DOUBLE*/
#define Z_COMPILER_HAS_C89_TYPE_UNSIGNED_CHAR TRUE
#define Z_COMPILER_HAS_C89_TYPE_UNSIGNED_LONG TRUE
#define Z_COMPILER_HAS_C89_TYPE_UNSIGNED_SHORT TRUE
#define Z_COMPILER_HAS_C89_TYPE_VOID TRUE
#define Z_COMPILER_HAS_C89_TYPE_VOID_POINTER TRUE
#define Z_COMPILER_HAS_C89_TYPE_MODIFIER_SIGNED TRUE
#define Z_COMPILER_HAS_C89_TYPE_QUALIFIER_CONST TRUE
/*#define Z_COMPILER_HAS_C89_TYPE_QUALIFIER_VOLATILE*/

/* MARK: - Language: C95 */

/*#define Z_COMPILER_HAS_C95_DIGRAPHS*/

/* MARK: - Language: C99 */

/*#define Z_COMPILER_HAS_C99_COMPOUND_LITERAL*/
/*#define Z_COMPILER_HAS_C99_CONVERSION_OF_NON_LVALUE_ARRAY_TO_POINTER*/
/*#define Z_COMPILER_HAS_C99_CPP_STYLE_COMMENT*/
/*#define Z_COMPILER_HAS_C99_DESIGNATED_INITIALIZATION*/
/*#define Z_COMPILER_HAS_C99_EMPTY_MACRO_ARGUMENT*/
/*#define Z_COMPILER_HAS_C99_EXTENDED_IDENTIFIER*/
/*#define Z_COMPILER_HAS_C99_FLEXIBLE_ARRAY_MEMBER*/
/*#define Z_COMPILER_HAS_C99_FOR_WITH_DECLARATION*/
/*#define Z_COMPILER_HAS_C99_IDEMPOTENT_TYPE_QUALIFIERS*/
/*#define Z_COMPILER_HAS_C99_MIXED_DECLARATIONS_AND_CODE*/
/*#define Z_COMPILER_HAS_C99_NON_CONSTANT_INITIALIZATION_FOR_LOCAL_AGGREGATE*/
/*#define Z_COMPILER_HAS_C99_PREPROCESSOR_ARITHMETIC_DONE_IN_INTMAX*/
/*#define Z_COMPILER_HAS_C99_RELIABLE_INTEGER_DIVISION*/
/*#define Z_COMPILER_HAS_C99_REMOVAL_OF_ILL_FORMED_RETURN*/
/*#define Z_COMPILER_HAS_C99_REMOVAL_OF_IMPLICIT_FUNCTION_DECLARATION*/
/*#define Z_COMPILER_HAS_C99_REMOVAL_OF_IMPLICIT_INT*/
/*#define Z_COMPILER_HAS_C99_STATIC_IN_ARRAY_PARAMETER_DECLARATION*/
/*#define Z_COMPILER_HAS_C99_TRAILING_COMMA_ALLOWED_IN_ENUMERATION*/
/*#define Z_COMPILER_HAS_C99_TYPE_QUALIFIERS_IN_ARRAY_PARAMETER_DECLARATION*/
/*#define Z_COMPILER_HAS_C99_UNIVERSAL_CHARACTER_NAME*/
/*#define Z_COMPILER_HAS_C99_VARIADIC_MACRO*/
/*#define Z_COMPILER_HAS_C99_VLA*/
/*#define Z_COMPILER_HAS_C99_IDENTIFIER_FUNC*/
/*#define Z_COMPILER_HAS_C99_LITERAL_HEXADECIMAL_FLOATING_POINT*/
/*#define Z_COMPILER_HAS_C99_PREPROCESSOR_OPERATOR_PRAGMA*/
/*#define Z_COMPILER_HAS_C99_SPECIFIER_INLINE*/
/*#define Z_COMPILER_HAS_C99_STD_PRAGMA_CX_LIMITED_RANGE*/
/*#define Z_COMPILER_HAS_C99_STD_PRAGMA_FENV_ACCESS*/
/*#define Z_COMPILER_HAS_C99_STD_PRAGMA_FP_CONTRACT*/
/*#define Z_COMPILER_HAS_C99_TYPE_BOOL*/
/*#define Z_COMPILER_HAS_C99_TYPE_DOUBLE_COMPLEX*/
/*#define Z_COMPILER_HAS_C99_TYPE_DOUBLE_IMAGINARY*/
/*#define Z_COMPILER_HAS_C99_TYPE_FLOAT_COMPLEX*/
/*#define Z_COMPILER_HAS_C99_TYPE_FLOAT_IMAGINARY*/
/*#define Z_COMPILER_HAS_C99_TYPE_LONG_DOUBLE_COMPLEX*/
/*#define Z_COMPILER_HAS_C99_TYPE_LONG_DOUBLE_IMAGINARY*/
/*#define Z_COMPILER_HAS_C99_TYPE_LONG_LONG*/
/*#define Z_COMPILER_HAS_C99_TYPE_MODIFIER_COMPLEX*/
/*#define Z_COMPILER_HAS_C99_TYPE_MODIFIER_IMAGINARY*/
/*#define Z_COMPILER_HAS_C99_TYPE_QUALIFIER_RESTRICT*/

/* MARK: - Language: C11 */

/*#define Z_COMPILER_HAS_C11_ANONYMOUS_STRUCTURE_AS_MEMBER*/
/*#define Z_COMPILER_HAS_C11_ANONYMOUS_UNION_AS_MEMBER*/
/*#define Z_COMPILER_HAS_C11_GENERIC_SELECTION*/
/*#define Z_COMPILER_HAS_C11_STATIC_ASSERTION*/
/*#define Z_COMPILER_HAS_C11_TYPEDEF_REDECLARATION*/
/*#define Z_COMPILER_HAS_C11_LITERAL_CHAR16_T_CHARACTER*/
/*#define Z_COMPILER_HAS_C11_LITERAL_CHAR16_T_STRING*/
/*#define Z_COMPILER_HAS_C11_LITERAL_CHAR32_T_CHARACTER*/
/*#define Z_COMPILER_HAS_C11_LITERAL_CHAR32_T_STRING*/
/*#define Z_COMPILER_HAS_C11_LITERAL_UTF8_STRING*/
/*#define Z_COMPILER_HAS_C11_OPERATOR_ALIGNOF*/
/*#define Z_COMPILER_HAS_C11_SPECIFIER_ALIGNAS*/
/*#define Z_COMPILER_HAS_C11_SPECIFIER_NORETURN*/
/*#define Z_COMPILER_HAS_C11_STORAGE_CLASS_THREAD_LOCAL*/
/*#define Z_COMPILER_HAS_C11_TYPE_MODIFIER_ATOMIC*/
/*#define Z_COMPILER_HAS_C11_TYPE_QUALIFIER_ATOMIC*/

/* MARK: - Language: Apple C extensions */

/*#define Z_COMPILER_HAS_APPLE_C_BLOCK_OBJECT*/

/* MARK: - Language: Clang C extensions */

/*#define Z_COMPILER_HAS_CLANG_C_PREPROCESSOR_OPERATOR_HAS_INCLUDE*/

#ifdef __cplusplus

	/* MARK: - Language: C++98 */

#	ifdef _CPPUNWIND
#		define Z_COMPILER_HAS_CPP98_EXCEPTIONS TRUE
#	endif

#	ifdef _CPPRTTI
#		define Z_COMPILER_HAS_CPP98_RTTI TRUE
#	endif

/*#	define Z_COMPILER_HAS_CPP98_SFINAE*/

#	if defined(__BOOL_DEFINED) && __BOOL_DEFINED == 1
#		define Z_COMPILER_HAS_CPP98_TYPE_BOOL TRUE
#	endif

#	ifdef _NATIVE_WCHAR_T_DEFINED
#		define Z_COMPILER_HAS_CPP98_TYPE_WCHAR_T TRUE
#	endif

	/* MARK: - Language: C++03 */

/*#	define Z_COMPILER_HAS_CPP03_VALUE_INITIALIZATION*/

	/* MARK: - Language: C++11 */

/*#	define Z_COMPILER_HAS_CPP11_ANONYMOUS_TYPE_AS_TEMPLATE_ARGUMENT*/
/*#	define Z_COMPILER_HAS_CPP11_C99_PREPROCESSOR*/
/*#	define Z_COMPILER_HAS_CPP11_COPY_LIST_INITIALIZATION*/
/*#	define Z_COMPILER_HAS_CPP11_DEFAULT_MEMBER_INITIALIZER*/
/*#	define Z_COMPILER_HAS_CPP11_DEFAULT_TEMPLATE_ARGUMENTS_FOR_FUNCTION_TEMPLATE*/
/*#	define Z_COMPILER_HAS_CPP11_DELEGATING_CONSTRUCTORS*/
/*#	define Z_COMPILER_HAS_CPP11_DELETED_FUNCTION*/
/*#	define Z_COMPILER_HAS_CPP11_DIRECT_LIST_INITIALIZATION*/
/*#	define Z_COMPILER_HAS_CPP11_EXPLICIT_CONVERSION_OPERATOR*/
/*#	define Z_COMPILER_HAS_CPP11_EXPLICITLY_DEFAULTED_SPECIAL_MEMBER_FUNCTION*/
/*#	define Z_COMPILER_HAS_CPP11_EXPRESSION_SFINAE*/
/*#	define Z_COMPILER_HAS_CPP11_EXTENDED_FRIEND_DECLARATION*/
/*#	define Z_COMPILER_HAS_CPP11_EXTENDED_VARIADIC_TEMPLATE_TEMPLATE_PARAMETERS*/
/*#	define Z_COMPILER_HAS_CPP11_EXTERN_TEMPLATE*/
/*#	define Z_COMPILER_HAS_CPP11_FIXED_ENUMERATION*/
/*#	define Z_COMPILER_HAS_CPP11_INHERITING_CONSTRUCTORS*/
/*#	define Z_COMPILER_HAS_CPP11_INITIALIZATION_OF_CLASS_OBJECT_BY_RVALUE*/
/*#	define Z_COMPILER_HAS_CPP11_INITIALIZER_LIST*/
/*#	define Z_COMPILER_HAS_CPP11_INLINE_NAMESPACE*/
/*#	define Z_COMPILER_HAS_CPP11_LAMBDA*/
/*#	define Z_COMPILER_HAS_CPP11_LOCAL_TYPE_AS_TEMPLATE_ARGUMENT*/
/*#	define Z_COMPILER_HAS_CPP11_MOVE_SPECIAL_MEMBER_FUNCTIONS*/
/*#	define Z_COMPILER_HAS_CPP11_MULTI_DECLARATOR_AUTO*/
/*#	define Z_COMPILER_HAS_CPP11_OPAQUE_ENUMERATION_DECLARATION*/
/*#	define Z_COMPILER_HAS_CPP11_RANGE_BASED_FOR*/
/*#	define Z_COMPILER_HAS_CPP11_REFERENCE_QUALIFIED_NON_STATIC_MEMBER_FUNCTION*/
/*#	define Z_COMPILER_HAS_CPP11_REMOVAL_OF_AUTO_AS_STORAGE_CLASS*/
/*#	define Z_COMPILER_HAS_CPP11_RIGHT_ANGLE_BRACKETS*/
/*#	define Z_COMPILER_HAS_CPP11_RVALUE_REFERENCE*/
/*#	define Z_COMPILER_HAS_CPP11_SCOPED_ENUMERATION*/
/*#	define Z_COMPILER_HAS_CPP11_STD_LAYOUT*/
/*#	define Z_COMPILER_HAS_CPP11_STANDARDIZED_ATTRIBUTE_SYNTAX*/
/*#	define Z_COMPILER_HAS_CPP11_STATIC_ASSERTION*/
/*#	define Z_COMPILER_HAS_CPP11_THREAD_SAFE_STATIC_INITIALIZATION*/
/*#	define Z_COMPILER_HAS_CPP11_TRAILING_COMMA_ALLOWED_IN_ENUMERATION*/
/*#	define Z_COMPILER_HAS_CPP11_TRAILING_RETURN_TYPE*/
/*#	define Z_COMPILER_HAS_CPP11_TYPE_ALIAS*/
/*#	define Z_COMPILER_HAS_CPP11_TYPE_ALIAS_TEMPLATE*/
/*#	define Z_COMPILER_HAS_CPP11_UNIVERSAL_CHARACTER_NAME*/
/*#	define Z_COMPILER_HAS_CPP11_UNRESTRICTED_UNION*/
/*#	define Z_COMPILER_HAS_CPP11_VARIADIC_TEMPLATE*/
/*#	define Z_COMPILER_HAS_CPP11_ATTRIBUTE_CARRIES_DEPENDENCY*/
/*#	define Z_COMPILER_HAS_CPP11_ATTRIBUTE_NORETURN*/
/*#	define Z_COMPILER_HAS_CPP11_IDENTIFIER_FUNC*/
/*#	define Z_COMPILER_HAS_CPP11_LITERAL_NULLPTR*/
/*#	define Z_COMPILER_HAS_CPP11_LITERAL_RAW_STRING*/
/*#	define Z_COMPILER_HAS_CPP11_LITERAL_USER_DEFINED*/
/*#	define Z_COMPILER_HAS_CPP11_LITERAL_UTF8_STRING*/
/*#	define Z_COMPILER_HAS_CPP11_OPERATOR_ALIGNOF*/
/*#	define Z_COMPILER_HAS_CPP11_OPERATOR_NOEXCEPT*/
/*#	define Z_COMPILER_HAS_CPP11_OPERATOR_CASE_SIZEOF_NON_STATIC_DATA_MEMBER*/
/*#	define Z_COMPILER_HAS_CPP11_OPERATOR_CASE_SIZEOF_PARAMETER_PACK*/
/*#	define Z_COMPILER_HAS_CPP11_SPECIFIER_ALIGNAS*/
/*#	define Z_COMPILER_HAS_CPP11_SPECIFIER_CONSTEXPR*/
/*#	define Z_COMPILER_HAS_CPP11_SPECIFIER_DECLTYPE*/
/*#	define Z_COMPILER_HAS_CPP11_SPECIFIER_FINAL*/
/*#	define Z_COMPILER_HAS_CPP11_SPECIFIER_NOEXCEPT*/
/*#	define Z_COMPILER_HAS_CPP11_SPECIFIER_OVERRIDE*/
/*#	define Z_COMPILER_HAS_CPP11_SPECIFIER_CASE_DECLTYPE_INCOMPLETE_RETURN_TYPE*/
/*#	define Z_COMPILER_HAS_CPP11_STORAGE_CLASS_THREAD_LOCAL*/
/*#	define Z_COMPILER_HAS_CPP11_TYPE_AUTO*/
/*#	define Z_COMPILER_HAS_CPP11_TYPE_CHAR16_T*/
/*#	define Z_COMPILER_HAS_CPP11_TYPE_CHAR32_T*/
/*#	define Z_COMPILER_HAS_CPP11_TYPE_LONG_LONG*/

	/* MARK: - Language: C++14 */

/*#	define Z_COMPILER_HAS_CPP14_APOSTROPHE_AS_DIGIT_SEPARATOR*/
/*#	define Z_COMPILER_HAS_CPP14_CONSTEXPR_FUNCTION*/
/*#	define Z_COMPILER_HAS_CPP14_CONTEXTUAL_CONVERSION*/
/*#	define Z_COMPILER_HAS_CPP14_DEFAULT_MEMBER_INITIALIZER_FOR_AGGREGATE*/
/*#	define Z_COMPILER_HAS_CPP14_GENERIC_LAMBDA*/
/*#	define Z_COMPILER_HAS_CPP14_INITIALIZED_LAMBDA_CAPTURE*/
/*#	define Z_COMPILER_HAS_CPP14_RETURN_TYPE_DEDUCTION_FOR_NORMAL_FUNCTION*/
/*#	define Z_COMPILER_HAS_CPP14_SIZED_DEALLOCATION*/
/*#	define Z_COMPILER_HAS_CPP14_VARIABLE_TEMPLATE*/
/*#	define Z_COMPILER_HAS_CPP14_ATTRIBUTE_DEPRECATED*/
/*#	define Z_COMPILER_HAS_CPP14_LITERAL_BINARY_INTEGRAL*/
/*#	define Z_COMPILER_HAS_CPP14_SPECIFIER_CASE_DECLTYPE_AUTO*/

	/* MARK: - Language: C++17 */

/*#	define Z_COMPILER_HAS_CPP17_AGGREGATE_INITIALIZATION_FOR_DERIVED_CLASS*/
/*#	define Z_COMPILER_HAS_CPP17_ATTRIBUTE_USING_PREFIX*/
/*#	define Z_COMPILER_HAS_CPP17_ATTRIBUTES_FOR_ENUMERATOR*/
/*#	define Z_COMPILER_HAS_CPP17_ATTRIBUTES_FOR_NAMESPACE*/
/*#	define Z_COMPILER_HAS_CPP17_AUTO_DEDUCTION_FROM_LIST_INITIALIZATION*/
/*#	define Z_COMPILER_HAS_CPP17_CONSTEXPR_IF*/
/*#	define Z_COMPILER_HAS_CPP17_CONSTEXPR_LAMBDA*/
/*#	define Z_COMPILER_HAS_CPP17_DEDUCTION_GUIDES_FOR_CLASS_TEMPLATE*/
/*#	define Z_COMPILER_HAS_CPP17_DIFFERING_BEGIN_AND_END_TYPES_IN_RANGE_BASED_FOR*/
/*#	define Z_COMPILER_HAS_CPP17_DIRECT_LIST_INITIALIZATION_FOR_FIXED_ENUMERATION*/
/*#	define Z_COMPILER_HAS_CPP17_EXPRESSION_EVALUATION_ORDER*/
/*#	define Z_COMPILER_HAS_CPP17_FOLD_EXPRESSION*/
/*#	define Z_COMPILER_HAS_CPP17_GUARANTEED_COPY_ELISION*/
/*#	define Z_COMPILER_HAS_CPP17_IF_WITH_INITIALIZER*/
/*#	define Z_COMPILER_HAS_CPP17_IGNORING_OF_UNKNOWN_ATTRIBUTES*/
/*#	define Z_COMPILER_HAS_CPP17_INHERITING_CONSTRUCTORS*/
/*#	define Z_COMPILER_HAS_CPP17_INLINE_VARIABLE*/
/*#	define Z_COMPILER_HAS_CPP17_LAMBDA_CAPTURE_OF_STAR_THIS_BY_VALUE*/
/*#	define Z_COMPILER_HAS_CPP17_NESTED_NAMESPACE_DEFINITION*/
/*#	define Z_COMPILER_HAS_CPP17_NOEXCEPT_AS_PART_OF_THE_FUNCTION_TYPE*/
/*#	define Z_COMPILER_HAS_CPP17_NON_TYPE_TEMPLATE_ARGUMENTS*/
/*#	define Z_COMPILER_HAS_CPP17_NON_TYPE_TEMPLATE_PARAMETER_WITH_AUTO_TYPE*/
/*#	define Z_COMPILER_HAS_CPP17_OVER_ALIGNED_DYNAMIC_MEMORY_ALLOCATION*/
/*#	define Z_COMPILER_HAS_CPP17_REMOVAL_OF_BOOL_INCREMENT*/
/*#	define Z_COMPILER_HAS_CPP17_REMOVAL_OF_DYNAMIC_EXCEPTION_SPECIFICATION*/
/*#	define Z_COMPILER_HAS_CPP17_REMOVAL_OF_REGISTER_AS_STORAGE_CLASS*/
/*#	define Z_COMPILER_HAS_CPP17_REMOVAL_OF_TRIGRAPHS*/
/*#	define Z_COMPILER_HAS_CPP17_SAFE_UNARY_FOLD_EXPRESSION*/
/*#	define Z_COMPILER_HAS_CPP17_STATIC_ASSERTION_WITH_NO_MESSAGE*/
/*#	define Z_COMPILER_HAS_CPP17_STRUCTURED_BINDING*/
/*#	define Z_COMPILER_HAS_CPP17_SWITCH_WITH_INITIALIZER*/
/*#	define Z_COMPILER_HAS_CPP17_TEMPLATE_TEMPLATE_ARGUMENT_MATCHING*/
/*#	define Z_COMPILER_HAS_CPP17_TYPENAME_IN_TEMPLATE_TEMPLATE_PARAMETER*/
/*#	define Z_COMPILER_HAS_CPP17_VARIADIC_USING*/
/*#	define Z_COMPILER_HAS_CPP17_ATTRIBUTE_FALLTHROUGH*/
/*#	define Z_COMPILER_HAS_CPP17_ATTRIBUTE_MAYBE_UNUSED*/
/*#	define Z_COMPILER_HAS_CPP17_ATTRIBUTE_NODISCARD*/
/*#	define Z_COMPILER_HAS_CPP17_LITERAL_HEXADECIMAL_FLOATING_POINT*/
/*#	define Z_COMPILER_HAS_CPP17_LITERAL_UTF8_CHARACTER*/
/*#	define Z_COMPILER_HAS_CPP17_PREPROCESSOR_OPERATOR_HAS_INCLUDE*/

#endif

/* MARK: - Language: Implementation-defined */

/*#define Z_COMPILER_HAS_ARITHMETIC_RIGHT_SHIFT*/

/* MARK: - Non-standard language: Attributes */

/*#define Z_COMPILER_ATTRIBUTE_ALIAS*/
#define Z_COMPILER_ATTRIBUTE_API_EXPORT __declspec(dllexport)
#define Z_COMPILER_ATTRIBUTE_API_IMPORT __declspec(dllimport)
/*#define Z_COMPILER_ATTRIBUTE_API_WEAK_EXPORT*/
/*#define Z_COMPILER_ATTRIBUTE_EBCO*/
#define Z_COMPILER_ATTRIBUTE_INLINE __inline
#define Z_COMPILER_ATTRIBUTE_MICROSOFT_STD_CALL __stdcall
/*#define Z_COMPILER_ATTRIBUTE_NO_RETURN*/
/*#define Z_COMPILER_ATTRIBUTE_NULL_TERMINATED*/
/*#define Z_COMPILER_ATTRIBUTE_PRIVATE*/
/*#define Z_COMPILER_ATTRIBUTE_PUBLIC*/
#define Z_COMPILER_ATTRIBUTE_THREAD_LOCAL __declspec(thread)
/*#define Z_COMPILER_ATTRIBUTE_WEAK*/

/* MARK: - Non-standard language: Structure padding */

/*#define Z_COMPILER_DEFINE_PACKED_STRUCTURE_BEFORE_TYPEDEF*/
/*#define Z_COMPILER_DEFINE_PACKED_STRUCTURE_BEFORE_STRUCT*/
/*#define Z_COMPILER_DEFINE_PACKED_STRUCTURE_BEFORE_BODY*/
/*#define Z_COMPILER_DEFINE_PACKED_STRUCTURE_BEFORE_TYPE*/
/*#define Z_COMPILER_DEFINE_PACKED_STRUCTURE_AFTER_TYPE*/
/*#define Z_COMPILER_DEFINE_PACKED_UNION_BEFORE_TYPEDEF*/
/*#define Z_COMPILER_DEFINE_PACKED_UNION_BEFORE_UNION*/
/*#define Z_COMPILER_DEFINE_PACKED_UNION_BEFORE_BODY*/
/*#define Z_COMPILER_DEFINE_PACKED_UNION_BEFORE_TYPE*/
/*#define Z_COMPILER_DEFINE_PACKED_UNION_AFTER_TYPE*/
/*#define Z_COMPILER_PACKED_NAMED_STRUCTURE_BEFORE_STRUCT*/
/*#define Z_COMPILER_PACKED_NAMED_STRUCTURE_BEFORE_TYPE*/
/*#define Z_COMPILER_PACKED_NAMED_STRUCTURE_BEFORE_BODY*/
/*#define Z_COMPILER_PACKED_NAMED_STRUCTURE_AFTER_BODY*/
/*#define Z_COMPILER_PACKED_NAMED_UNION_BEFORE_UNION*/
/*#define Z_COMPILER_PACKED_NAMED_UNION_BEFORE_TYPE*/
/*#define Z_COMPILER_PACKED_NAMED_UNION_BEFORE_BODY*/
/*#define Z_COMPILER_PACKED_NAMED_UNION_AFTER_BODY*/
/*#define Z_COMPILER_PACKED_UNNAMED_STRUTURE_BEFORE_STRUCT*/
/*#define Z_COMPILER_PACKED_UNNAMED_STRUTURE_BEFORE_BODY*/
/*#define Z_COMPILER_PACKED_UNNAMED_STRUTURE_BEFORE_IDENTIFIER*/
/*#define Z_COMPILER_PACKED_UNNAMED_STRUTURE_AFTER_IDENTIFIER*/
/*#define Z_COMPILER_PACKED_UNNAMED_UNION_BEFORE_STRUCT*/
/*#define Z_COMPILER_PACKED_UNNAMED_UNION_BEFORE_BODY*/
/*#define Z_COMPILER_PACKED_UNNAMED_UNION_BEFORE_IDENTIFIER*/
/*#define Z_COMPILER_PACKED_UNNAMED_UNION_AFTER_IDENTIFIER*/

/* MARK: - Built-ins: Types and literal suffixes */

#define Z_COMPILER_TYPE_UINT8  unsigned __int8
#define Z_COMPILER_TYPE_SINT8		__int8
#define Z_COMPILER_TYPE_UINT16 unsigned __int16
#define Z_COMPILER_TYPE_SINT16		__int16
/*#define Z_COMPILER_TYPE_UINT24*/
/*#define Z_COMPILER_TYPE_SINT24*/
#define Z_COMPILER_TYPE_UINT32 unsigned __int32
#define Z_COMPILER_TYPE_SINT32		__int32
/*#define Z_COMPILER_TYPE_UINT40*/
/*#define Z_COMPILER_TYPE_SINT40*/
/*#define Z_COMPILER_TYPE_UINT48*/
/*#define Z_COMPILER_TYPE_SINT48*/
/*#define Z_COMPILER_TYPE_UINT56*/
/*#define Z_COMPILER_TYPE_SINT56*/
#define Z_COMPILER_TYPE_UINT64 unsigned __int64
#define Z_COMPILER_TYPE_SINT64		__int64
/*#define Z_COMPILER_TYPE_UINT128*/
/*#define Z_COMPILER_TYPE_SINT128*/
/*#define Z_COMPILER_TYPE_BFP16*/
/*#define Z_COMPILER_TYPE_BFP32*/
/*#define Z_COMPILER_TYPE_BFP64*/
/*#define Z_COMPILER_TYPE_BFP128*/
/*#define Z_COMPILER_TYPE_DFP32*/
/*#define Z_COMPILER_TYPE_DFP64*/
/*#define Z_COMPILER_TYPE_DFP128*/
/*#define Z_COMPILER_TYPE_X87_DE80*/
/*#define Z_COMPILER_TYPE_X87_DE96*/
/*#define Z_COMPILER_TYPE_X87_DE128*/
/*#define Z_COMPILER_TYPE_IBM_ED*/
/*#define Z_COMPILER_TYPE_BFLOAT16*/
/*#define Z_COMPILER_TYPE_VAL*/
/*#define Z_COMPILER_LITERAL_UINT8(number)*/
/*#define Z_COMPILER_LITERAL_SINT8(number)*/
/*#define Z_COMPILER_LITERAL_UINT16(number)*/
/*#define Z_COMPILER_LITERAL_SINT16(number)*/
/*#define Z_COMPILER_LITERAL_UINT24(number)*/
/*#define Z_COMPILER_LITERAL_SINT24(number)*/
/*#define Z_COMPILER_LITERAL_UINT32(number)*/
/*#define Z_COMPILER_LITERAL_SINT32(number)*/
/*#define Z_COMPILER_LITERAL_UINT40(number)*/
/*#define Z_COMPILER_LITERAL_SINT40(number)*/
/*#define Z_COMPILER_LITERAL_UINT48(number)*/
/*#define Z_COMPILER_LITERAL_SINT48(number)*/
/*#define Z_COMPILER_LITERAL_UINT56(number)*/
/*#define Z_COMPILER_LITERAL_SINT56(number)*/
/*#define Z_COMPILER_LITERAL_UINT64(number)*/
/*#define Z_COMPILER_LITERAL_SINT64(number)*/
/*#define Z_COMPILER_LITERAL_UINT128(number)*/
/*#define Z_COMPILER_LITERAL_SINT128(number)*/
/*#define Z_COMPILER_LITERAL_BFP16(number)*/
/*#define Z_COMPILER_LITERAL_BFP32(number)*/
/*#define Z_COMPILER_LITERAL_BFP64(number)*/
/*#define Z_COMPILER_LITERAL_BFP128(number)*/
/*#define Z_COMPILER_LITERAL_DFP32(number)*/
/*#define Z_COMPILER_LITERAL_DFP64(number)*/
/*#define Z_COMPILER_LITERAL_DFP128(number)*/
/*#define Z_COMPILER_LITERAL_X87_DE80(number)*/
/*#define Z_COMPILER_LITERAL_X87_DE96(number)*/
/*#define Z_COMPILER_LITERAL_X87_DE128(number)*/
/*#define Z_COMPILER_LITERAL_IBM_ED(number)*/
/*#define Z_COMPILER_LITERAL_BFLOAT16(number)*/

/* MARK: - Built-ins: Constants */

/*#define Z_COMPILER_CONSTANT_CHAR_BITS*/
/*#define Z_COMPILER_CONSTANT_UCHAR_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SCHAR_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SCHAR_MINIMUM*/
/*#define Z_COMPILER_CONSTANT_SHORT_BITS*/
/*#define Z_COMPILER_CONSTANT_SHORT_SIZE*/
/*#define Z_COMPILER_CONSTANT_USHORT_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SSHORT_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SSHORT_MINIMUM*/
/*#define Z_COMPILER_CONSTANT_INT_BITS*/
/*#define Z_COMPILER_CONSTANT_INT_SIZE*/
/*#define Z_COMPILER_CONSTANT_UINT_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SINT_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SINT_MINIMUM*/
/*#define Z_COMPILER_CONSTANT_LONG_BITS*/
/*#define Z_COMPILER_CONSTANT_LONG_SIZE*/
/*#define Z_COMPILER_CONSTANT_ULONG_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SLONG_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SLONG_MINIMUM*/
/*#define Z_COMPILER_CONSTANT_LLONG_BITS*/
/*#define Z_COMPILER_CONSTANT_LLONG_SIZE*/
/*#define Z_COMPILER_CONSTANT_ULLONG_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SLLONG_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SLLONG_MINIMUM*/
/*#define Z_COMPILER_CONSTANT_WCHAR_BITS*/
/*#define Z_COMPILER_CONSTANT_WCHAR_SIZE*/
/*#define Z_COMPILER_CONSTANT_WCHAR_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_WCHAR_MINIMUM*/
/*#define Z_COMPILER_CONSTANT_SIZE_BITS*/
/*#define Z_COMPILER_CONSTANT_SIZE_SIZE*/
/*#define Z_COMPILER_CONSTANT_USIZE_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SSIZE_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SSIZE_MINIMUM*/
/*#define Z_COMPILER_CONSTANT_UINTMAX_BITS*/
/*#define Z_COMPILER_CONSTANT_UINTMAX_SIZE*/
/*#define Z_COMPILER_CONSTANT_UINTMAX_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SINTMAX_BITS*/
/*#define Z_COMPILER_CONSTANT_SINTMAX_SIZE*/
/*#define Z_COMPILER_CONSTANT_SINTMAX_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SINTMAX_MINIMUM*/
/*#define Z_COMPILER_CONSTANT_UINTPTR_BITS*/
/*#define Z_COMPILER_CONSTANT_UINTPTR_SIZE*/
/*#define Z_COMPILER_CONSTANT_UINTPTR_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SINTPTR_BITS*/
/*#define Z_COMPILER_CONSTANT_SINTPTR_SIZE*/
/*#define Z_COMPILER_CONSTANT_SINTPTR_MAXIMUM*/
/*#define Z_COMPILER_CONSTANT_SINTPTR_MINIMUM*/
/*#define Z_COMPILER_CONSTANT_FLOAT_BITS*/
/*#define Z_COMPILER_CONSTANT_FLOAT_SIZE*/
/*#define Z_COMPILER_CONSTANT_FLOAT_HUGE*/
/*#define Z_COMPILER_CONSTANT_FLOAT_INFINITY*/
/*#define Z_COMPILER_CONSTANT_FLOAT_QNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT_SNAN*/
/*#define Z_COMPILER_CONSTANT_DOUBLE_BITS*/
/*#define Z_COMPILER_CONSTANT_DOUBLE_SIZE*/
/*#define Z_COMPILER_CONSTANT_DOUBLE_HUGE*/
/*#define Z_COMPILER_CONSTANT_DOUBLE_INFINITY*/
/*#define Z_COMPILER_CONSTANT_DOUBLE_QNAN*/
/*#define Z_COMPILER_CONSTANT_DOUBLE_SNAN*/
/*#define Z_COMPILER_CONSTANT_LDOUBLE_BITS*/
/*#define Z_COMPILER_CONSTANT_LDOUBLE_SIZE*/
/*#define Z_COMPILER_CONSTANT_LDOUBLE_HUGE*/
/*#define Z_COMPILER_CONSTANT_LDOUBLE_INFINITY*/
/*#define Z_COMPILER_CONSTANT_LDOUBLE_QNAN*/
/*#define Z_COMPILER_CONSTANT_LDOUBLE_SNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT16_HUGE*/
/*#define Z_COMPILER_CONSTANT_FLOAT16_INFINITY*/
/*#define Z_COMPILER_CONSTANT_FLOAT16_QNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT16_SNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT32_HUGE*/
/*#define Z_COMPILER_CONSTANT_FLOAT32_INFINITY*/
/*#define Z_COMPILER_CONSTANT_FLOAT32_QNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT32_SNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT64_HUGE*/
/*#define Z_COMPILER_CONSTANT_FLOAT64_INFINITY*/
/*#define Z_COMPILER_CONSTANT_FLOAT64_QNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT64_SNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT128_HUGE*/
/*#define Z_COMPILER_CONSTANT_FLOAT128_INFINITY*/
/*#define Z_COMPILER_CONSTANT_FLOAT128_QNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT128_SNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT32X_HUGE*/
/*#define Z_COMPILER_CONSTANT_FLOAT32X_INFINITY*/
/*#define Z_COMPILER_CONSTANT_FLOAT32X_QNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT32X_SNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT64X_HUGE*/
/*#define Z_COMPILER_CONSTANT_FLOAT64X_INFINITY*/
/*#define Z_COMPILER_CONSTANT_FLOAT64X_QNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT64X_SNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT128X_HUGE*/
/*#define Z_COMPILER_CONSTANT_FLOAT128X_INFINITY*/
/*#define Z_COMPILER_CONSTANT_FLOAT128X_QNAN*/
/*#define Z_COMPILER_CONSTANT_FLOAT128X_SNAN*/
/*#define Z_COMPILER_CONSTANT_DECIMAL32_HUGE*/
/*#define Z_COMPILER_CONSTANT_DECIMAL32_INFINITY*/
/*#define Z_COMPILER_CONSTANT_DECIMAL32_QNAN*/
/*#define Z_COMPILER_CONSTANT_DECIMAL32_SNAN*/
/*#define Z_COMPILER_CONSTANT_DECIMAL64_HUGE*/
/*#define Z_COMPILER_CONSTANT_DECIMAL64_INFINITY*/
/*#define Z_COMPILER_CONSTANT_DECIMAL64_QNAN*/
/*#define Z_COMPILER_CONSTANT_DECIMAL64_SNAN*/
/*#define Z_COMPILER_CONSTANT_DECIMAL128_HUGE*/
/*#define Z_COMPILER_CONSTANT_DECIMAL128_INFINITY*/
/*#define Z_COMPILER_CONSTANT_DECIMAL128_QNAN*/
/*#define Z_COMPILER_CONSTANT_DECIMAL128_SNAN*/
/*#define Z_COMPILER_CONSTANT_DECIMAL64X_HUGE*/
/*#define Z_COMPILER_CONSTANT_DECIMAL64X_INFINITY*/
/*#define Z_COMPILER_CONSTANT_DECIMAL64X_QNAN*/
/*#define Z_COMPILER_CONSTANT_DECIMAL64X_SNAN*/
/*#define Z_COMPILER_CONSTANT_DECIMAL128X_HUGE*/
/*#define Z_COMPILER_CONSTANT_DECIMAL128X_INFINITY*/
/*#define Z_COMPILER_CONSTANT_DECIMAL128X_QNAN*/
/*#define Z_COMPILER_CONSTANT_DECIMAL128X_SNAN*/
/*#define Z_COMPILER_CONSTANT_BFP16_HUGE*/
/*#define Z_COMPILER_CONSTANT_BFP16_INFINITY*/
/*#define Z_COMPILER_CONSTANT_BFP16_QNAN*/
/*#define Z_COMPILER_CONSTANT_BFP16_SNAN*/
/*#define Z_COMPILER_CONSTANT_BFP32_HUGE*/
/*#define Z_COMPILER_CONSTANT_BFP32_INFINITY*/
/*#define Z_COMPILER_CONSTANT_BFP32_QNAN*/
/*#define Z_COMPILER_CONSTANT_BFP32_SNAN*/
/*#define Z_COMPILER_CONSTANT_BFP64_HUGE*/
/*#define Z_COMPILER_CONSTANT_BFP64_INFINITY*/
/*#define Z_COMPILER_CONSTANT_BFP64_QNAN*/
/*#define Z_COMPILER_CONSTANT_BFP64_SNAN*/
/*#define Z_COMPILER_CONSTANT_BFP128_HUGE*/
/*#define Z_COMPILER_CONSTANT_BFP128_INFINITY*/
/*#define Z_COMPILER_CONSTANT_BFP128_QNAN*/
/*#define Z_COMPILER_CONSTANT_BFP128_SNAN*/
/*#define Z_COMPILER_CONSTANT_DFP32_HUGE*/
/*#define Z_COMPILER_CONSTANT_DFP32_INFINITY*/
/*#define Z_COMPILER_CONSTANT_DFP32_QNAN*/
/*#define Z_COMPILER_CONSTANT_DFP32_SNAN*/
/*#define Z_COMPILER_CONSTANT_DFP64_HUGE*/
/*#define Z_COMPILER_CONSTANT_DFP64_INFINITY*/
/*#define Z_COMPILER_CONSTANT_DFP64_QNAN*/
/*#define Z_COMPILER_CONSTANT_DFP64_SNAN*/
/*#define Z_COMPILER_CONSTANT_DFP128_HUGE*/
/*#define Z_COMPILER_CONSTANT_DFP128_INFINITY*/
/*#define Z_COMPILER_CONSTANT_DFP128_QNAN*/
/*#define Z_COMPILER_CONSTANT_DFP128_SNAN*/
/*#define Z_COMPILER_CONSTANT_X87_DE80_HUGE*/
/*#define Z_COMPILER_CONSTANT_X87_DE80_INFINITY*/
/*#define Z_COMPILER_CONSTANT_X87_DE80_QNAN*/
/*#define Z_COMPILER_CONSTANT_X87_DE80_SNAN*/
/*#define Z_COMPILER_CONSTANT_X87_DE96_HUGE*/
/*#define Z_COMPILER_CONSTANT_X87_DE96_INFINITY*/
/*#define Z_COMPILER_CONSTANT_X87_DE96_QNAN*/
/*#define Z_COMPILER_CONSTANT_X87_DE96_SNAN*/
/*#define Z_COMPILER_CONSTANT_X87_DE128_HUGE*/
/*#define Z_COMPILER_CONSTANT_X87_DE128_INFINITY*/
/*#define Z_COMPILER_CONSTANT_X87_DE128_QNAN*/
/*#define Z_COMPILER_CONSTANT_X87_DE128_SNAN*/
/*#define Z_COMPILER_CONSTANT_IBM_ED_HUGE*/
/*#define Z_COMPILER_CONSTANT_IBM_ED_INFINITY*/
/*#define Z_COMPILER_CONSTANT_IBM_ED_QNAN*/
/*#define Z_COMPILER_CONSTANT_IBM_ED_SNAN*/
/*#define Z_COMPILER_CONSTANT_BFLOAT16_HUGE*/
/*#define Z_COMPILER_CONSTANT_BFLOAT16_INFINITY*/
/*#define Z_COMPILER_CONSTANT_BFLOAT16_QNAN*/
/*#define Z_COMPILER_CONSTANT_BFLOAT16_SNAN*/
/*#define Z_COMPILER_CONSTANT_POINTER_BITS*/
/*#define Z_COMPILER_CONSTANT_POINTER_SIZE*/

/* MARK: - Built-ins: Macros */

/*#define Z_COMPILER_MACRO_MEMBER_OFFSET(type, member)*/
/*#define Z_COMPILER_MACRO_VAL_INITIALIZE(self, last_parameter)*/
/*#define Z_COMPILER_MACRO_VAL_FINALIZE(self)*/
/*#define Z_COMPILER_MACRO_VAL_READ(self, type)*/
/*#define Z_COMPILER_MACRO_VAL_COPY(self, output)*/

/* MARK: - Built-ins: Functions */

/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_ADD_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_AND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_AND_ADD(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_AND_AND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_AND_NAND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_AND_OR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_AND_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_AND_SUBTRACT(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_AND_XOR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_NAND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_OR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_SUBTRACT_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT8_ATOMIC_XOR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_ADD_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_AND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_AND_ADD(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_AND_AND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_AND_NAND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_AND_OR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_AND_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_AND_SUBTRACT(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_AND_XOR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_NAND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_OR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_SUBTRACT_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT8_ATOMIC_XOR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_ADD_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_AND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_AND_ADD(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_AND_AND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_AND_NAND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_AND_OR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_AND_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_AND_SUBTRACT(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_AND_XOR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_NAND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_OR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_SUBTRACT_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT16_ATOMIC_XOR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_ADD_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_AND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_AND_ADD(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_AND_AND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_AND_NAND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_AND_OR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_AND_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_AND_SUBTRACT(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_AND_XOR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_NAND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_OR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_SUBTRACT_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT16_ATOMIC_XOR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_ADD_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_AND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_AND_ADD(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_AND_AND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_AND_NAND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_AND_OR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_AND_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_AND_SUBTRACT(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_AND_XOR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_NAND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_OR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_SUBTRACT_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT32_ATOMIC_XOR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_ADD_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_AND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_AND_ADD(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_AND_AND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_AND_NAND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_AND_OR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_AND_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_AND_SUBTRACT(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_AND_XOR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_NAND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_OR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_SUBTRACT_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT32_ATOMIC_XOR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_ADD_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_AND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_AND_ADD(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_AND_AND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_AND_NAND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_AND_OR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_AND_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_AND_SUBTRACT(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_AND_XOR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_NAND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_OR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_SUBTRACT_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT64_ATOMIC_XOR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_ADD_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_AND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_AND_ADD(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_AND_AND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_AND_NAND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_AND_OR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_AND_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_AND_SUBTRACT(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_AND_XOR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_NAND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_OR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_SUBTRACT_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT64_ATOMIC_XOR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_ADD_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_AND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_AND_ADD(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_AND_AND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_AND_NAND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_AND_OR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_AND_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_AND_SUBTRACT(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_AND_XOR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_NAND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_OR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_SUBTRACT_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_UINT128_ATOMIC_XOR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_ADD_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_AND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_AND_ADD(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_AND_AND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_AND_NAND(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_AND_OR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_AND_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_AND_SUBTRACT(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_AND_XOR(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_NAND_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_OR_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_SET_IF_EQUAL(value, old_value, new_value)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_SUBTRACT_AND_GET(value, operand)*/
/*#define Z_COMPILER_FUNCTION_SINT128_ATOMIC_XOR_AND_GET(value, operand)*/

/* MARK: - Built-ins: Traits */

/*#define Z_COMPILER_TRAIT_SELECT_TYPE(I, ...)*/
/*#define Z_COMPILER_TRAIT_TYPE_DIMENSION_COUNT(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_ELEMENT_COUNT(T, dimension_index)*/
/*#define Z_COMPILER_TRAIT_TYPE_HAS_UNIQUE_OBJECT_REPRESENTATIONS(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_HAS_VIRTUAL_DESTRUCTOR(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_ABSTRACT(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_AGGREGATE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_ARITHMETIC(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_ARRAY(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_ASSIGNABLE(T, from_type)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_BASE(T, of_type)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_COMPLETE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_COMPOUND(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_CONST(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_CONSTRUCTIBLE(T, ...)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_CONVERTIBLE(T, to_type)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_DATA_MEMBER_POINTER(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_DESTRUCTIBLE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_EMPTY(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_ENUMERATION(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_FINAL(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_INTEGRAL(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_INTERFACE_CLASS(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_FLOATING_POINT(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_FUNCTION(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_FUNDAMENTAL(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_LITERAL(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_LVALUE_REFERENCE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_MEMBER_FUNCTION_POINTER(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_MEMBER_POINTER(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_NOTHROW_ASSIGNABLE(T, from_type)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_NOTHROW_CONSTRUCTIBLE(T, ...)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_NOTHROW_COPY_ASSIGNABLE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_NOTHROW_COPY_CONSTRUCTIBLE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_NOTHROW_DEFAULT_CONSTRUCTIBLE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_NOTHROW_DESTRUCTIBLE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_NOTHROW_MOVE_ASSIGNABLE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_OBJECT(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_POD(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_POINTER(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_POLYMORPHIC(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_REFERENCE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_RVALUE_REFERENCE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_SAME(T, as_type)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_SCALAR(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_SEALED(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_SIGNED(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_STD_LAYOUT(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_STRUCTURE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_TRIVIAL(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_ASSIGNABLE(T, from_type)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_CONSTRUCTIBLE(T, ...)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_COPY_ASSIGNABLE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_COPY_CONSTRUCTIBLE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_COPYABLE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_DEFAULT_CONSTRUCTIBLE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_DESTRUCTIBLE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_UNION(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_UNSIGNED(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_VOID(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_IS_VOLATILE(T)*/
/*#define Z_COMPILER_TRAIT_TYPE_UNDERLYING_TYPE(T)*/

#endif /* Z_inspection_compiler_modules_MSVC_H */
