/* Zeta API - Z/keys/OS.h
 ______ ____________  ___
|__   /|  ___|__  __|/   \
  /  /_|  __|  |  | /  *  \
 /_____|_____| |__|/__/ \__\
Copyright (C) 2006-2022 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef Z_keys_OS_H
#define Z_keys_OS_H
				    /* First released by	   Official website									      */
#define Z_OS_UNKNOWN		  0 /* --------------------------  ------------------------------------------------------------------------------------------ */
#define Z_OS_AEGIS		  1 /* Apollo Computer													      */
#define Z_OS_AIX		  2 /* IBM			   <https://www.ibm.com/it-infrastructure/power/os/aix>					      */
#define Z_OS_AMIGA_OS		  3 /* Commodore		   <https://www.amigaos.net>								      */
#define Z_OS_ANANAS_OS		  4 /* Springer, Rink		   <https://ananas-os.readthedocs.io>							      */
#define Z_OS_ANDROID		  5 /* Google			   <https://www.android.com>								      */
#define Z_OS_AROS		  6 /* AROS Development Team. The  <http://http://www.aros.org>								      */
#define Z_OS_BE_OS		  7 /* Be			   <http://www.beincorporated.com>							      */
#define Z_OS_BITRIG		  8 /*				   <https://www.bitrig.org>								      */
#define Z_OS_BSD_386		  9 /* Berkeley Software Design												      */
#define Z_OS_CELL_OS		 10 /* Sony (PS3)													      */
#define Z_OS_CNK		 11 /* IBM														      */
#define Z_OS_CONVEX_UNIX	 12 /* Convex Computer													      */
#define Z_OS_CYGWIN		 13 /* Cygnus Solutions		   <https://www.cygwin.com>								      */
#define Z_OS_DC_OSX		 14 /* Pyramid Technology												      */
#define Z_OS_DG_UX		 15 /* Data General													      */
#define Z_OS_DOMAIN_OS		 16 /* Apollo Computer													      */
#define Z_OS_DRAGONFLY_BSD	 17 /* Dillon, Matthew		   <https://www.dragonflybsd.org>							      */
#define Z_OS_DYNIX_PTX		 18 /* Sequent Computer Systems												      */
#define Z_OS_ECOS		 19 /* Cygnus Solutions		   <http://ecos.sourceware.org>								      */
#define Z_OS_FREE_BSD		 20 /* FreeBSD Project, The	   <https://www.freebsd.org>								      */
#define Z_OS_FUCHSIA		 21 /* Google			   <https://fuchsia.googlesource.com>							      */
#define Z_OS_GNU_HURD		 22 /* GNU			   <https://www.gnu.org/software/hurd>							      */
#define Z_OS_HAIKU		 23 /* Haiku			   <https://www.haiku-os.org>								      */
#define Z_OS_HI_UX_MPP		 24 /* Hitachi			   <http://www.hitachi.co.jp/Prod/comp/soft1/HI-UX/mpp>					      */
#define Z_OS_HP_UX		 25 /* Hewlett-Packard		   <http://www.hpe.com/info/hpux>							      */
#define Z_OS_INTEGRITY		 26 /* Green Hills Software	   <https://www.ghs.com/products/rtos/integrity.html>					      */
#define Z_OS_IPHONE_OS		 27 /* Apple			   <https://www.apple.com/ios>								      */
#define Z_OS_IRIX		 28 /* SGI			   <http://www.sgi.com/products/software/irix>						      */
#define Z_OS_LEMON_OS		 29 /* Roberts-White, J.J. 	   <https://lemonos.org>								      */
#define Z_OS_LINUX		 30 /* Torvalds, Linus		   <https://www.kernel.org>								      */
#define Z_OS_LUNIX		 31 /* Dallmann, Daniel		   <http://lng.sourceforge.net/>							      */
#define Z_OS_LYNX_OS		 32 /* Lynx Software Technologies  <https://www.lynx.com/products/lynxos-posix-real-time-operating-system-rtos>		      */
#define Z_OS_MAC_OS		 33 /* Apple Computer		   <http://apple.com/macos>								      */
#define Z_OS_MAC_OS_X		 34 /* Apple Computer		   <https://www.apple.com/macos>							      */
#define Z_OS_MINIX		 35 /* Tanenbaum, Andrew Stuart	   <http://www.minix3.org>								      */
#define Z_OS_MORPH_OS		 36 /* MorphOS Development Team	   <http://www.morphos-team.net>							      */
#define Z_OS_MPE_XL		 37 /* Hewlett-Packard													      */
#define Z_OS_MS_DOS		 38 /* Microsoft													      */
#define Z_OS_NET_BSD		 39 /* NetBSD Foundation, The	   <http://www.netbsd.org>								      */
#define Z_OS_NETWARE		 40 /* Novell			   <http://www.novell.com/products/netware>						      */
#define Z_OS_NON_STOP_OS	 41 /* Hewlett-Packard		   <http://hpe.com/info/nonstop>							      */
#define Z_OS_NUCLEUS_RTOS	 42 /* Mentor Graphics		   <https://www.mentor.com/embedded-software/nucleus>					      */
#define Z_OS_OPEN_BSD		 43 /* de Raadt, Theo		   <http://www.openbsd.org>								      */
#define Z_OS_OPEN_VMS		 44 /* DEC			   <http://www.vmssoftware.com>								      */
#define Z_OS_ORBIS_OS		 45 /* Sony (PS4)													      */
#define Z_OS_OS_2		 46 /* IBM / Microsoft		   <http://www-306.ibm.com/software/os/warp>						      */
#define Z_OS_OS_9		 47 /* Microware Systems	   <http://www.microware.com>								      */
#define Z_OS_OS_400		 48 /* IBM			   <https://www.ibm.com/it-infrastructure/power/os/ibm-i>				      */
#define Z_OS_OSF_1		 49 /* DEC			   <http://h30097.www3.hp.com>								      */
#define Z_OS_PALM_OS		 50 /* Palm			   <http://www.access-company.com/products/platforms/garnet>				      */
#define Z_OS_PLAN_9		 51 /* Bell Labs		   <http://plan9.bell-labs.com>								      */
#define Z_OS_PSP_SYSTEM_SOFTWARE 52 /* Sony (PSP)													      */
#define Z_OS_QNX		 53 /* Quantum Software Systems	   <http://www.qnx.com>									      */
#define Z_OS_RTEMS		 54 /* OAR Corporation (?)	   <https://www.rtems.org>								      */
#define Z_OS_SCO_UNIX_SYSTEM_V	 55 /* SCO			   <https://www.xinuos.com/menu-products/openserver-10>					      */
#define Z_OS_SERENITY_OS	 56 /* Kling, Andreas		   <http://serenityos.org>								      */
#define Z_OS_SINIX		 57 /* Siemens Nixdorf													      */
#define Z_OS_SOLARIS		 58 /* Sun Microsystems		   <https://www.oracle.com/solaris>							      */
#define Z_OS_SUN_OS		 59 /* Sun Microsystems													      */
#define Z_OS_SYLLABLE		 60 /*				   <http://www.syllable.org>								      */
#define Z_OS_SYMBIAN		 61 /* Symbian			   <http://symbian.nokia.com>								      */
#define Z_OS_TVOS		 62 /* Apple			   <https://developer.apple.com/tvos>							      */
#define Z_OS_ULTRIX		 63 /* DEC														      */
#define Z_OS_UNICOS		 64 /* Cray														      */
#define Z_OS_UNICOS_MP		 65 /* SGI (?)														      */
#define Z_OS_UNIXWARE		 66 /* Univel			   <https://www.xinuos.com/menu-products/unixware-2018>					      */
#define Z_OS_UTS		 67 /* Amdahl														      */
#define Z_OS_VOS		 68 /* Stratus Technologies	   <https://www.stratus.com/solutions/platforms/v-series-continuum-openvos/operating-systems> */
#define Z_OS_VX_WORKS		 69 /* Wind River Systems	   <https://www.windriver.com/products/vxworks>						      */
#define Z_OS_WATCH_OS		 70 /* Apple			   <https://www.apple.com/watchos>							      */
#define Z_OS_WINDOWS		 71 /* Microsoft		   <https://www.microsoft.com/windows>							      */
#define Z_OS_WINDOWS_CE		 72 /* Microsoft		   <http://msdn.microsoft.com/embedded>							      */
#define Z_OS_Z_OS		 73 /* IBM			   <https://www.ibm.com/it-infrastructure/z/zos>					      */
#define Z_OS_ZETA		 74 /* yellowTAB		   <http://http://www.zeta-os.com>							      */

#define Z_OS_NAME_AEGIS		      "AEGIS"
#define Z_OS_NAME_AIX		      "AIX"
#define Z_OS_NAME_AMIGA_OS	      "AmigaOS"
#define Z_OS_NAME_ANANAS_OS	      "Ananas/OS"
#define Z_OS_NAME_ANDROID	      "Android"
#define Z_OS_NAME_AROS		      "AROS"
#define Z_OS_NAME_BE_OS		      "BeOS"
#define Z_OS_NAME_BITRIG	      "Bitrig"
#define Z_OS_NAME_BSD_386	      "BSD/386"
#define Z_OS_NAME_CELL_OS	      "CellOS"
#define Z_OS_NAME_CNK		      "CNK"
#define Z_OS_NAME_CONVEX_UNIX	      "Convex UNIX"
#define Z_OS_NAME_CYGWIN	      "Cygwin"
#define Z_OS_NAME_DC_OSX	      "DC/OSx"
#define Z_OS_NAME_DG_UX		      "DG/UX"
#define Z_OS_NAME_DOMAIN_OS	      "Domain/OS"
#define Z_OS_NAME_DRAGONFLY_BSD	      "DragonFly BSD"
#define Z_OS_NAME_DYNIX_PTX	      "DYNIX/ptx"
#define Z_OS_NAME_ECOS		      "eCos"
#define Z_OS_NAME_FREE_BSD	      "FreeBSD"
#define Z_OS_NAME_FUCHSIA	      "Fuchsia"
#define Z_OS_NAME_GNU_HURD	      "GNU Hurd"
#define Z_OS_NAME_HAIKU		      "Haiku"
#define Z_OS_NAME_HI_UX_MPP	      "HI-UX/MPP"
#define Z_OS_NAME_HP_UX		      "HP-UX"
#define Z_OS_NAME_INTEGRITY	      "INTEGRITY"
#define Z_OS_NAME_IPHONE_OS	      "iPhone OS"
#define Z_OS_NAME_IRIX		      "IRIX"
#define Z_OS_NAME_LEMON_OS	      "Lemon OS"
#define Z_OS_NAME_LINUX		      "Linux"
#define Z_OS_NAME_LUNIX		      "LUnix"
#define Z_OS_NAME_LYNX_OS	      "LynxOS"
#define Z_OS_NAME_MAC_OS	      "Mac OS"
#define Z_OS_NAME_MAC_OS_X	      "Mac OS X"
#define Z_OS_NAME_MINIX		      "MINIX"
#define Z_OS_NAME_MORPH_OS	      "MorphOS"
#define Z_OS_NAME_MPE_XL	      "MPE XL"
#define Z_OS_NAME_MS_DOS	      "MS-DOS"
#define Z_OS_NAME_NET_BSD	      "NetBSD"
#define Z_OS_NAME_NETWARE	      "NetWare"
#define Z_OS_NAME_NON_STOP_OS	      "NonStop OS"
#define Z_OS_NAME_NUCLEUS_RTOS	      "Nucleus RTOS"
#define Z_OS_NAME_OPEN_BSD	      "OpenBSD"
#define Z_OS_NAME_OPEN_VMS	      "OpenVMS"
#define Z_OS_NAME_ORBIS_OS	      "Orbis OS"
#define Z_OS_NAME_OS_2		      "OS/2"
#define Z_OS_NAME_OS_9		      "OS-9"
#define Z_OS_NAME_OS_400	      "OS/400"
#define Z_OS_NAME_OSF_1		      "OSF/1"
#define Z_OS_NAME_PALM_OS	      "Palm OS"
#define Z_OS_NAME_PLAN_9	      "Plan 9"
#define Z_OS_NAME_PSP_SYSTEM_SOFTWARE "PlayStation Portable System Software"
#define Z_OS_NAME_QNX		      "QNX"
#define Z_OS_NAME_RTEMS		      "RTEMS"
#define Z_OS_NAME_SCO_UNIX_SYSTEM_V   "SCO UNIX System V"
#define Z_OS_NAME_SERENITY_OS	      "SerenityOS"
#define Z_OS_NAME_SINIX		      "SINIX"
#define Z_OS_NAME_SOLARIS	      "Solaris"
#define Z_OS_NAME_SUN_OS	      "SunOS"
#define Z_OS_NAME_SYLLABLE	      "Syllable"
#define Z_OS_NAME_SYMBIAN	      "Symbian"
#define Z_OS_NAME_TVOS		      "tvOS"
#define Z_OS_NAME_ULTRIX	      "ULTRIX"
#define Z_OS_NAME_UNICOS	      "UNICOS"
#define Z_OS_NAME_UNICOS_MP	      "UNICOS/mp"
#define Z_OS_NAME_UNIXWARE	      "UnixWare"
#define Z_OS_NAME_UTS		      "UTS"
#define Z_OS_NAME_VOS		      "VOS"
#define Z_OS_NAME_VX_WORKS	      "VxWorks"
#define Z_OS_NAME_WATCH_OS	      "Watch OS"
#define Z_OS_NAME_WINDOWS	      "Windows"
#define Z_OS_NAME_WINDOWS_CE	      "Windows CE"
#define Z_OS_NAME_Z_OS		      "z/OS"
#define Z_OS_NAME_ZETA		      "ZETA"

#define Z_OS_BSD_I	  Z_OS_BSD_386
#define Z_OS_BSD_OS	  Z_OS_BSD_386
#define Z_OS_CONVEX_OS	  Z_OS_CONVEX_UNIX
#define Z_OS_DIGITAL_UNIX Z_OS_OSF_1
#define Z_OS_I5_OS	  Z_OS_OS_400
#define Z_OS_IBM_I	  Z_OS_OS_400
#define Z_OS_IOS	  Z_OS_IPHONE_OS
#define Z_OS_MACOS	  Z_OS_MAC_OS_X
#define Z_OS_OPEN_DESKTOP Z_OS_SCO_UNIX_SYSTEM_V
#define Z_OS_OPEN_SERVER  Z_OS_SCO_UNIX_SYSTEM_V /* Not sure */
#define Z_OS_OPEN_UNIX	  Z_OS_UNIXWARE
#define Z_OS_OS_X	  Z_OS_MAC_OS_X
#define Z_OS_RELIANT_UNIX Z_OS_SINIX
#define Z_OS_SCO_UNIX	  Z_OS_SCO_UNIX_SYSTEM_V
#define Z_OS_TRU64_UNIX	  Z_OS_OSF_1
#define Z_OS_WATCHOS	  Z_OS_WATCH_OS

#define Z_OS_NAME_BSD_I	       "BSDi"
#define Z_OS_NAME_BSD_OS       "BSD/OS"
#define Z_OS_NAME_CONVEX_OS    "ConvexOS"
#define Z_OS_NAME_DIGITAL_UNIX "Digital UNIX"
#define Z_OS_NAME_I5_OS	       "i5/OS"
#define Z_OS_NAME_IBM_I	       "IBM i"
#define Z_OS_NAME_IOS	       "iOS"
#define Z_OS_NAME_MACOS	       "macOS"
#define Z_OS_NAME_OPEN_DESKTOP "Open Desktop"
#define Z_OS_NAME_OPEN_SERVER  "OpenServer"
#define Z_OS_NAME_OPEN_UNIX    "Open UNIX"
#define Z_OS_NAME_OS_X	       "OS X"
#define Z_OS_NAME_RELIANT_UNIX "Reliant UNIX"
#define Z_OS_NAME_SCO_UNIX     "SCO UNIX"
#define Z_OS_NAME_TRU64_UNIX   "Tru64 UNIX"
#define Z_OS_NAME_WATCHOS      "watchOS"

#endif /* Z_keys_OS_H */
