/* Zeta API - Z/keys/platform.h
 ______ ____________  ___
|__   /|  ___|__  __|/   \
  /  /_|  __|  |  | /  *  \
 /_____|_____| |__|/__/ \__\
Copyright (C) 2006-2022 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef Z_keys_platform_H
#define Z_keys_platform_H

#define Z_PLATFORM_UNKNOWN 0

/* Computers */

#define Z_PLATFORM_ABC_80	      1001 /* Luxor			   */
#define Z_PLATFORM_ABC_800	      1002 /* Luxor			   */
#define Z_PLATFORM_ALPHATRONIC_PC     1003 /* Triumph-Adler		   */
#define Z_PLATFORM_AMIGA	      1004 /* Commodore			   */
#define Z_PLATFORM_APPLE_II	      1005 /* Apple Computer		   */
#define Z_PLATFORM_AQUARIUS	      1006 /* Mattel			   */
#define Z_PLATFORM_ATMOS	      1007 /* Oric			   */
#define Z_PLATFORM_BBC_MICRO	      1008 /* Acorn Computers		   */
#define Z_PLATFORM_CBM_IIB	      1009 /* Commodore			   */
#define Z_PLATFORM_CBM_IIP	      1010 /* Commodore			   */
#define Z_PLATFORM_CHALLENGER_1P      1011 /* Ohio Scientific		   */
#define Z_PLATFORM_COMMANDER_X16      1012 /* Murray, David		   */
#define Z_PLATFORM_COMMODORE_16	      1013 /* Commodore			   */
#define Z_PLATFORM_COMMODORE_64	      1014 /* Commodore			   */
#define Z_PLATFORM_COMMODORE_128      1015 /* Commodore			   */
#define Z_PLATFORM_CPC		      1016 /* Amstrad			   */
#define Z_PLATFORM_GALAKSIJA	      1017 /* Antonić, Vojislav		   */
#define Z_PLATFORM_JUPITER_ACE	      1018 /* Jupiter Cantab		   */
#define Z_PLATFORM_MACINTOSH	      1019 /* Apple			   */
#define Z_PLATFORM_M5		      1020 /* SORD			   */
#define Z_PLATFORM_MSX		      1021 /* Microsoft and others	   */
#define Z_PLATFORM_QL		      1022 /* Sinclair Research		   */
#define Z_PLATFORM_PET		      1023 /* Commodore			   */
#define Z_PLATFORM_PLUS_4	      1024 /* Commodore			   */
#define Z_PLATFORM_RX_78	      1025 /* Bandai			   */
#define Z_PLATFORM_SAM_COUPE	      1026 /* Miles Gordon Technology	   */
#define Z_PLATFORM_SORCERER	      1026 /* Exidy			   */
#define Z_PLATFORM_ST		      1027 /* Atari			   */
/*#define Z_PLATFORM_TELESTRAT	      1028*/ /* Oric / Euréka		   */
#define Z_PLATFORM_VIC_20	      1029 /* Commodore			   */
#define Z_PLATFORM_X_07		      1030 /* Canon			   */
#define Z_PLATFORM_X1		      1031 /* Sharp			   */
#define Z_PLATFORM_Z88		      1032 /* Cambridge Computer	   */
#define Z_PLATFORM_ZX80		      1033 /* Sinclair Research		   */
#define Z_PLATFORM_ZX81		      1034 /* Sinclair Research		   */
#define Z_PLATFORM_ZX_SPECTRUM	      1035 /* Sinclair Research		   */

/* Consoles */

#define Z_PLATFORM_3DO		      2001 /* The 3DO Company		   */
#define Z_PLATFORM_ATARI_2600	      2002 /* Atari			   */
#define Z_PLATFORM_ATARI_5200	      2003 /* Atari			   */
#define Z_PLATFORM_ATARI_7800	      2004 /* Atari			   */
#define Z_PLATFORM_CD_I		      2005 /* Philips			   */
#define Z_PLATFORM_COLECO_VISION      2006 /* Coleco Industries 	   */
#define Z_PLATFORM_CREATIVISION	      2007 /* VTech			   */
#define Z_PLATFORM_DREAMCAST	      2008 /* Sega			   */
#define Z_PLATFORM_GAMATE	      2009 /* Bit Corporation		   */
#define Z_PLATFORM_GAME_BOY	      2010 /* Nintendo			   */
#define Z_PLATFORM_GAME_BOY_ADVANCE   2011 /* Nintendo			   */
#define Z_PLATFORM_GAME_GEAR	      2012 /* Sega			   */
#define Z_PLATFORM_JAGUAR	      2013 /* Atari			   */
#define Z_PLATFORM_LYNX		      2014 /* Atari			   */
#define Z_PLATFORM_MASTER_SYSTEM      2015 /* Sega			   */
#define Z_PLATFORM_MEGA_DRIVE	      2016 /* Sega			   */
#define Z_PLATFORM_NEO_GEO	      2017 /* SNK			   */
#define Z_PLATFORM_NEO_GEO_POCKET     2018 /* SNK			   */
#define Z_PLATFORM_NES		      2019 /* Nintendo			   */
#define Z_PLATFORM_NINTENDO_3DS	      2020 /* Nintendo			   */
#define Z_PLATFORM_NINTENDO_64	      2021 /* Nintendo			   */
#define Z_PLATFORM_NINTENDO_DS	      2022 /* Nintendo			   */
#define Z_PLATFORM_NINTENDO_GAME_CUBE 2023 /* Nintendo			   */
#define Z_PLATFORM_NINTENDO_SWITCH    2024 /* Nintendo			   */
#define Z_PLATFORM_PC_ENGINE	      2025 /* NEC			   */
#define Z_PLATFORM_PLAYDIA	      2026 /* Bandai			   */
#define Z_PLATFORM_PSX		      2027 /* Sony			   */
#define Z_PLATFORM_PS2		      2028 /* Sony			   */
#define Z_PLATFORM_PS3		      2029 /* Sony			   */
#define Z_PLATFORM_PS4		      2030 /* Sony			   */
#define Z_PLATFORM_PSP		      2031 /* Sony			   */
#define Z_PLATFORM_PS_VITA	      2032 /* Sony			   */
#define Z_PLATFORM_SEGA_SATURN	      2033 /* Sega			   */
#define Z_PLATFORM_SNES		      2034 /* Nintendo			   */
#define Z_PLATFORM_SUPERVISION	      2035 /* Watara			   */
#define Z_PLATFORM_VECTREX	      2036 /* General Consumer Electronics */
#define Z_PLATFORM_VIRTUAL_BOY	      2037 /* Nintendo			   */
#define Z_PLATFORM_WII		      2038 /* Nintendo			   */
#define Z_PLATFORM_WII_U	      2039 /* Nintendo			   */
#define Z_PLATFORM_WONDER_SWAN	      2040 /* Bandai			   */
#define Z_PLATFORM_XBOX		      2041 /* Microsoft			   */
#define Z_PLATFORM_XBOX_360	      2042 /* Microsoft			   */
#define Z_PLATFORM_XBOX_ONE	      2043 /* Microsoft			   */


#endif /* Z_keys_platform_H */
